; packed data structure
struct LZSSData
  packed_size	  dd ?
  unpacked_size   dd ?
  data		  dd ?
ends


; packed file header
struct LZSSFileHeader
  id		dd ?
  unpacked_size dd ?
ends


; lzss settings

LZSS_THRESHOLD	     = 2

LZSS_COUNT_BITS      = 4
LZSS_OFFSET_BITS     = 12

LZSS_DICTIONARY_SIZE = (2 shl (LZSS_OFFSET_BITS-1))
LZSS_MAX_COUNT	     = (2 shl (LZSS_COUNT_BITS-1)) + LZSS_THRESHOLD

LZSS_NO_TREE = LZSS_DICTIONARY_SIZE