; Win32 programming headers (ASCII)

;========================================================================
; Macro library options
;========================================================================

..ShowSizes = 1        ; if 1 - displays the messages passed through
		       ; DispSize macro.

..ShowUserMessages = 1 ; if 1 - displays list with user defined Windows
		       ; messages - names and values, created by "message"
		       ; macro.

include '../macro/struct.inc'
include '../macro/exceptions.inc'
include '../macro/proc32.inc'
include '../macro/proc32ex.inc'
include '../macro/import32.inc'
include '../macro/export.inc'
include '../macro/display.inc'
include '../macro/globals.inc'

struc CHAR count { rb count }

include 'equates/kernel32.inc'
include 'equates/user32.inc'
include 'equates/gdi32.inc'
include 'equates/comctl32.inc'
include 'equates/comdlg32.inc'
include 'equates/shell32.inc'
include 'equates/wsock32.inc'
