message MWM_CLEARMESSAGES       ; Clears all messages in the message window

message MWM_ADDMESSAGE          ; wparam - pointer to TMsg structure describing the message.
                                ; lparam - handle of the parent item.
                                ; returns the handle of the new message line.

message MWM_FIRSTERROR          ; searches for the last root error message and opens the file.

struct TFileLine
  hFileName dd ?       ; handle to the filename string.
  pos       AEPOS      ; Position of cursor and selection in ASMEDIT control.
ends

struct TFreshMsg
  type        dd ?      ; 0..5
  hMessage    dd ?      ; ptr/handle of the message
  link        TFileLine ; File link information.
ends

mtWarning = 0
mtError = 1
mtInfo = 2
mtFind = 3
mtNone = 4
mtDebug = 5

