;<ff
Window frmEditorColors, 3, 0, 'TForm', 'Syntax colors', $46000000, $10200, 0, 260, 193, 348, 237, CustomWinProc;
Window NONE, 0, 0, 'BUTTON', '&Color', $50010000, $0, 104, 272, 176, 40, 24, 0;
Window NONE, 0, 0, 'TForm', '', $50000000, $200, 109, 176, 176, 88, 24, 0;
Window NONE, 0, 0, 'ASMEDIT', '', $58000167, $200, 200, 4, 32, 164, 168, 0;
Window NONE, 0, 0, 'LISTBOX', '', $50310141, $200, 106, 176, 24, 144, 144, 0;
Window NONE, 0, 0, 'STATIC', '&Font:', $50000200, $0, 0, 4, 4, 24, 19, 0;
Window NONE, 0, 0, 'STATIC', '&Syntax elements:', $50000200, $0, 0, 176, 4, 88, 19, 0;
Window NONE, 2, 0, 'TButtonEdit', 'ASIDY', $50010880, $200, 111, 32, 4, 137, 19, 0;
;ff>
iglobal

  cPreviewSource file 'PreviewSource.inc'
		 db   0

  cSynListboxColors:
	  IndexedStrings					  \
	    aeTheme.text_color,      'Default text',		  \
	    aeTheme.text_background, 'Default background',	  \
	    aeTheme.sel_text,	     'Selected text',		  \
	    aeTheme.sel_background,  'Selected background',	  \
	    aeTheme.active_color,     'Focused line text',	   \
	    aeTheme.active_background,'Focused line background',   \
	    aeTheme.margin_background,'Left margin background',   \
	    aeTheme.margin_border,    'Left margin border',	  \
	    aeTheme.syntax_colors+4*(clInstruction-1), 'Instruction',	\
	    aeTheme.syntax_colors+4*(clRegister-1),    'Register',	\
	    aeTheme.syntax_colors+4*(clSymbol-1),      'Symbol',	\
	    aeTheme.syntax_colors+4*(clNumber-1),      'Number',	\
	    aeTheme.syntax_colors+4*(clString-1),      'String',	\
	    aeTheme.syntax_colors+4*(clComment-1),     'Comment'

  cFontCharsets:
	  IndexedStrings			  \
	    ANSI_CHARSET	  , 'Western',	  \
	    DEFAULT_CHARSET	  , 'Default',	  \
	    SYMBOL_CHARSET	  , 'Symbol',	  \
	    SHIFTJIS_CHARSET	  , 'Shiftjis',   \
	    HANGEUL_CHARSET	  , 'Hangeul',	  \
	    GB2312_CHARSET	  , 'GB2312',	  \
	    CHINESEBIG5_CHARSET   , 'Chinese Big5',\
	    OEM_CHARSET 	  , 'OEM',	  \
	    JOHAB_CHARSET	  , 'Johab',	  \
	    HEBREW_CHARSET	  , 'Hebrew',	  \
	    ARABIC_CHARSET	  , 'Arabic',	  \
	    GREEK_CHARSET	  , 'Greek',	  \
	    TURKISH_CHARSET	  , 'Turkish',	  \
	    VIETNAMESE_CHARSET	  , 'Vietnamese', \
	    THAI_CHARSET	  , 'Thai',	  \
	    EASTEUROPE_CHARSET	  , 'Central European', \
	    RUSSIAN_CHARSET	  , 'Cyrillic', 	\
	    MAC_CHARSET 	  , 'Mac',		\
	    BALTIC_CHARSET	  , 'Baltic'
endg



winproc CustomWinProc

ondefault
	stc
	ret

onmessage FM_AFTERCREATE
locals
  .aep AEPOS
endl
; Fill listbox with color names.
	mov    esi, cSynListboxColors

.addloop:
	lodsd
	test	eax,eax
	jz	.OM_UPDATEDIALOG

	mov	ebx, [esi]
	add	esi, 4

	invoke	SendDlgItemMessage, [hwnd], 106, LB_ADDSTRING, 0, eax
	cmp	eax, LB_ERR
	je	.addloop

	invoke	SendDlgItemMessage, [hwnd], 106, LB_SETITEMDATA, eax, ebx
	jmp	.addloop

onmessage OM_UPDATEDIALOG
; Set properties for preview window.
	invoke	GetDlgItem, [hwnd], 200
	mov	esi, eax

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	ebx, eax

	stdcall ApplySettingsToAsmEdit, esi, ebx, fasm_syntax

	invoke	SendMessage, esi, WM_SETTEXT, 0, cPreviewSource
	invoke	SendMessage, esi, AEM_SETREADONLY, TRUE, 0

	invoke	SendMessage, esi, AEM_SETFLAGS, 2, FLAG_ACTIVE

	mov	[.aep.caretLine], 9
	mov	[.aep.caretPosition], 0
	mov	[.aep.selectionLine], 9
	mov	[.aep.selectionPosition], 255
	lea	eax, [.aep]
	invoke	SendMessage, esi, AEM_SETPOS, eax, 0

; Set font name size and charset

; Name
iglobal
  cComma db ', ',0
endg
	stdcall StrDup, [ebx+TEditorSettings.ptrFontName]
	mov	edi, eax
	stdcall StrCat, edi, cComma
; Size
	stdcall NumToStr, [ebx+TEditorSettings.FontSize], 0, 0, ntsDec or ntsZeroTerminated
	push	eax
	stdcall StrCat, edi, eax
	stdcall StrDel ; from the stack
	stdcall StrCat, edi, cComma

; Charset
	mov	ecx, [ebx+TEditorSettings.FontCharset]
	mov	esi, cFontCharsets
.setloop:
	lodsd
	test	eax, eax
	jz	.notfound

	mov	edx, eax
	lodsd
	cmp	eax, ecx
	jne	.setloop

	stdcall StrCat, edi, edx

.setfonttext:
	stdcall StrPtr, edi
	invoke	SendDlgItemMessage, [hwnd], 111, WM_SETTEXT, 0, eax
	stdcall StrDel, edi

; Set current selected color...
	invoke	SendDlgItemMessage, [hwnd], 106, LB_GETCURSEL, 0, 0
	cmp	eax, LB_ERR
	jne	.validselection

	invoke	GetDlgItem, [hwnd], 104
	invoke	EnableWindow, eax, FALSE
	invoke	GetProp, [hwnd], [propColor]
	invoke	SendDlgItemMessage, [hwnd], 109, FM_SETCOLOR, eax, 0
	clc
	ret

.validselection:
	invoke	SendDlgItemMessage, [hwnd], 106, LB_GETITEMDATA, eax, 0

	mov	edi, [ebx+TEditorSettings.ptrTheme]
	mov	eax, [edi+eax]
	invoke	SendDlgItemMessage, [hwnd], 109, FM_SETCOLOR, eax, 0

	invoke	GetDlgItem, [hwnd], 104
	invoke	EnableWindow, eax, TRUE

	clc
	ret

.notfound:
	stdcall NumToStr, ecx, 0, 0, ntsSigned or ntsZeroTerminated or ntsDec
	push	eax
	stdcall StrCat, edi, eax
	stdcall StrDel ; from the stack
	jmp	.setfonttext


	clc
	ret


onmessage WM_COMMAND
locals
  .cc CHOOSECOLOR
endl
	cmp	word [wparam+2], LBN_SELCHANGE
	je	.colorlistbox

	cmp	word [wparam], 104		    ; ID of the "Color" button
	je	.changecolor

	jmp	.ondefault

iglobal
  arrayCustomColors:
	times 16 dd $00ffffff
endg

.changecolor:
	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	edi, eax

	invoke	SendDlgItemMessage, [hwnd], 106, LB_GETCURSEL, 0, 0
	cmp	eax, LB_ERR
	je	.endcolorset

	invoke	SendDlgItemMessage, [hwnd], 106, LB_GETITEMDATA, eax, 0

	mov	edi, [edi+TEditorSettings.ptrTheme]
	lea	edi, [edi+eax]
	mov	eax, [edi]

	lea	esi, [.cc]
	mov	[esi+CHOOSECOLOR.lStructSize], sizeof.CHOOSECOLOR
	mov	[esi+CHOOSECOLOR.hwndOwner], 0
	mov	[esi+CHOOSECOLOR.rgbResult], eax
	mov	[esi+CHOOSECOLOR.lpCustColors], arrayCustomColors
	mov	[esi+CHOOSECOLOR.Flags], CC_RGBINIT or CC_ENABLEHOOK
	mov	[esi+CHOOSECOLOR.lpfnHook], CommonDialogHook

	invoke	ChooseColor, esi
	test	eax, eax
	jz	.endcolorset

	mov	eax, [esi+CHOOSECOLOR.rgbResult]
	mov	[edi], eax
	invoke	SendDlgItemMessage, [hwnd], 109, FM_SETCOLOR, eax, 0
	jmp	.OM_UPDATEDIALOG


.endcolorset:
	clc
	ret



.colorlistbox:
	movzx	eax, word [wparam]
	cmp	eax, 106   ; id of the list box.
	jne	.ondefault

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	esi, [eax+TEditorSettings.ptrTheme]

	invoke	SendMessage, [lparam], LB_GETCURSEL, 0, 0
	cmp	eax, LB_ERR
	je	.endcommand

	invoke	SendMessage, [lparam], LB_GETITEMDATA, eax, 0
	lea	esi, [esi+eax]

	invoke	SendDlgItemMessage, [hwnd], 109, FM_SETCOLOR, [esi], 0
	invoke	GetDlgItem, [hwnd], 104
	invoke	EnableWindow, eax, TRUE

.endcommand:
	xor	eax, eax
	clc
	ret


onmessage BEM_BUTTONCLICK
locals
  .cf CHOOSEFONT
  .lf LOGFONT
endl
	lea	esi, [.cf]
	mov	[esi+CHOOSEFONT.lStructSize], sizeof.CHOOSEFONT

	mov	[esi+CHOOSEFONT.hwndOwner], 0
	mov	[esi+CHOOSEFONT.Flags], CF_FIXEDPITCHONLY or CF_FORCEFONTEXIST or CF_NOVECTORFONTS or CF_SCREENFONTS or CF_INITTOLOGFONTSTRUCT or CF_ENABLEHOOK
	lea	eax, [.lf]
	mov	[esi+CHOOSEFONT.lpLogFont], eax
	mov	[esi+CHOOSEFONT.lpfnHook], CommonDialogHook

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	esi, eax

	mov	eax, [esi+TEditorSettings.FontSize]
	mov	ecx, [esi+TEditorSettings.FontCharset]
	mov	[.lf.lfHeight], eax
	mov	[.lf.lfCharSet], cl

	mov	esi, [esi+TEditorSettings.ptrFontName]
	mov	ecx, 32
	lea	edi, [.lf.lfFaceName]
	rep movsb

	lea	esi, [.cf]
	invoke	ChooseFont, esi
	test	eax, eax
	jz	.endfont

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	edi, eax

	mov	eax, [.lf.lfHeight]
	movzx	ecx, [.lf.lfCharSet]
	mov	[edi+TEditorSettings.FontSize], eax
	mov	[edi+TEditorSettings.FontCharset], ecx

	mov	edi, [edi+TEditorSettings.ptrFontName]
	mov	ecx, 32
	lea	esi, [.lf.lfFaceName]
	rep movsb

	jmp	.OM_UPDATEDIALOG

.endfont:
	clc
	ret

endwp


winproc CommonDialogHook
local .rect:RECT

	push	esi edi ebx
	mov	ebx, [wmsg]

ondefault
	xor	eax, eax
	pop	ebx edi esi
	ret

onmessage WM_INITDIALOG

	lea	eax, [.rect]
	invoke	GetWindowRect, [hwnd], eax

	invoke	GetSystemMetrics, SM_CXSCREEN
	sub	eax, [.rect.right]
	add	eax, [.rect.left]
	sar	eax,1
	mov	esi, eax

	invoke	GetSystemMetrics, SM_CYSCREEN
	sub	eax, [.rect.bottom]
	add	eax, [.rect.top]
	sar	eax,1
	mov	edi, eax

	invoke	SetWindowPos, [hwnd], 0, esi, edi, 0, 0, SWP_NOSIZE or SWP_NOZORDER

	mov	eax, 1
	pop	ebx edi esi
	ret
endwp

