;<ff
Window frmStyleEditor, 3, 0, 'TForm', 'Select styles', $6800000, $10080, 0, 225, 202, 360, 247, StyleEditorWinProc;
Window NONE, 0, 0, 'EDIT', '', $50810084, $0, 1000, 0, 200, 208, 20, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 288, 200, 64, 20, 0;
Window NONE, 0, 3, 'COMBOBOX', 'Combobox', $50010003, $0, 102, 0, 0, 352, 150, 0;
Window NONE, 0, 3, 'SysListView32', 'ListView', $50814005, $0, 101, 0, 21, 352, 171, 0;
Window NONE, 2, 0, 'BUTTON', 'OK', $50010001, $0, 1, 216, 200, 64, 20, 0;
;ff>
winproc StyleEditorWinProc
locals
.lvc LVCOLUMN
.lvi LVITEM
.ctrl dd ?
.style dd ?
.subtype dd ?
.cursub  dd ?
.index   dd ?
endl

ondefault
        stc
        ret

onmessage WM_COMMAND
        cmp     word [wparam+2], CBN_SELCHANGE
        jne     .ondefault
        jmp     .itemchanged

onmessage WM_NOTIFY

        mov     esi,[lparam]
        mov     eax,[esi+NMHDR.code]
        cmp     eax, LVN_ITEMCHANGED
        je      .itemchanged
        cmp     eax, LVN_ITEMACTIVATE
        jne     .ondefault

        invoke  SendDlgItemMessage, [hwnd], 101, LVM_GETITEMSTATE, [esi+NMLISTVIEW.iItem], LVIS_STATEIMAGEMASK

        xor     eax, $3000
        mov     [.lvi.state], eax
        mov     [.lvi.stateMask], LVIS_STATEIMAGEMASK
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETITEMSTATE, [esi+NMLISTVIEW.iItem], eax

        clc
        ret

.itemchanged:
        stdcall CreateBitValue, [hwnd]
        mov     ebx, eax

        invoke  SetWindowLong, [hwnd], 8, ebx

        stdcall NumToStr, ebx, NULL, 0, ntsHex or ntsZeroTerminated or ntsUnsigned
        push    eax
        stdcall StrInsertChar, eax, '$', 0

        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [hwnd], 1000, WM_SETTEXT, 0, eax
        stdcall StrDel ; from the stack.

        clc
        ret

onmessage FM_AFTERCREATE
        invoke  SendDlgItemMessage, [hwnd], 101,               \
                LVM_SETEXTENDEDLISTVIEWSTYLE, 0,                \
                LVS_EX_CHECKBOXES or LVS_EX_INFOTIP

        lea     eax, [.lvc]
        mov     [eax+LVCOLUMN.mask], LVCF_WIDTH or LVCF_FMT or LVCF_SUBITEM
        mov     [eax+LVCOLUMN.cx], 100
        mov     [eax+LVCOLUMN.fmt], LVCFMT_LEFT
        mov     [eax+LVCOLUMN.iSubItem], 0
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_INSERTCOLUMN, 0, eax

        lea     eax, [.lvc]
        mov     [eax+LVCOLUMN.iSubItem], 1
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_INSERTCOLUMN, 1, eax

        lea     eax, [.lvc]
        mov     [eax+LVCOLUMN.iSubItem], 2
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_INSERTCOLUMN, 2, eax

        clc
        ret

onmessage WM_INITDIALOG
        invoke  GetWindowLong, [hwnd], 4
        mov     [.ctrl], eax

        mov     ecx, [eax+TWinTemplateDT.style]
        mov     edi, [eax+TWinTemplateDT.DesignInfo]

        mov     [.style], ecx
        and     ecx, [edi+TDesignTimeInfo.SubtypeMask]
        mov     [.subtype], ecx

        invoke  SetWindowLong, [hwnd], 8, [eax+TWinTemplateDT.style]

; pointer to the subtype list of styles.
        mov     esi, [edi+TDesignTimeInfo.SubtypeRange]
        cmp     esi, edi
        jne     .wehavesubtypes

        invoke  SendDlgItemMessage, [hwnd], 102, CB_ADDSTRING, 0, cDefaultSubtype
        invoke  SendDlgItemMessage, [hwnd], 102, CB_SETITEMDATA, 0, 0
        invoke  SendDlgItemMessage, [hwnd], 102, CB_SETCURSEL, 0, 0
        jmp     .checksubtypescount

.wehavesubtypes:
        lodsd
        mov     ebx, eax        ; count of subtypes

.addsubtypes:
        dec     ebx
        js      .checksubtypescount

        lodsd   ; value
        mov     [.cursub], eax

        lodsb
        push    esi
        movzx   eax, al
        add     esi, eax

        invoke  SendDlgItemMessage, [hwnd], 102, CB_ADDSTRING, 0     ; lparam is already in the stack
        mov     [.index], eax

        invoke  SendDlgItemMessage, [hwnd], 102, CB_SETITEMDATA, [.index], [.cursub]

        mov     eax, [.cursub]
        cmp     eax, [.subtype]
        jne     .skiphint

        invoke  SendDlgItemMessage, [hwnd], 102, CB_SETCURSEL, [.index], 0

.skiphint:
        lodsb
        movzx   eax, al
        add     esi, eax
        jmp     .addsubtypes

.checksubtypescount:
        invoke  SendDlgItemMessage, [hwnd], 102, CB_GETCOUNT, 0, 0
        cmp     eax, 1
        ja      .addstyles

        invoke  GetDlgItem, [hwnd], 102
        invoke  EnableWindow, eax, FALSE

.addstyles:
        mov     esi, [edi+TDesignTimeInfo.StyleNames]
        cmp     esi, edi
        je      @f
        call    .AddWinStylesArray
@@:
        mov     esi, CommonStyles
        call    .AddWinStylesArray

; set the width of the list view columns
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETCOLUMNWIDTH, 1, LVSCW_AUTOSIZE
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETCOLUMNWIDTH, 2, LVSCW_AUTOSIZE

        clc
        ret


.AddWinStylesArray:
        lodsd
        mov     ebx, eax        ; count of items.

.addloop:
        dec     ebx
        jns     .doloop
        retn

.doloop:
        lodsd   ; the value
        mov     [.lvi.lParam], eax

        lodsb
        movzx   eax, al
        mov     [.lvi.pszText], esi
        add     esi, eax              ; string with help text.

        mov     [.lvi.mask], LVIF_TEXT or LVIF_PARAM
        mov     [.lvi.iItem], 0
        mov     [.lvi.iSubItem], 0

        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_INSERTITEM, 0, eax

        mov     [.lvi.iItem], eax

        mov     [.lvi.stateMask], LVIS_STATEIMAGEMASK
        mov     [.lvi.state], $1000

        mov     eax, [.style]
        and     eax, [.lvi.lParam]
        cmp     eax, [.lvi.lParam]
        jne     .setcheckmark

        add     [.lvi.state], $1000

.setcheckmark:
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETITEMSTATE, [.lvi.iItem], eax

        mov     [.lvi.iSubItem], 1
        stdcall NumToStr, [.lvi.lParam], 0, 0, ntsHex or ntsUnsigned or ntsZeroTerminated
        push    eax
        stdcall StrInsertChar, eax, '$', 0
        stdcall StrPtr, eax
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETITEMTEXT, [.lvi.iItem], eax
        stdcall StrDel ; from the stack.

        mov     [.lvi.iSubItem], 2
        lodsb
        movzx   eax, al
        mov     [.lvi.pszText], esi
        add     esi, eax                ; next style.

        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_SETITEMTEXT, [.lvi.iItem], eax

        jmp     .addloop


onmessage WM_SHOWWINDOW
        cmp     [wparam], FALSE
        jne     .ondefault

        invoke  GetWindowLong, [hwnd], GWL_HWNDPARENT
        invoke  GetDlgItem, eax, 101
        mov     ebx, eax

        invoke  GetDlgItem, [hwnd], 1000
        stdcall GetControlText, eax, 0
        push    eax

        stdcall StrPtr, eax
        invoke  SendMessage, ebx, PEM_SETEDITORTEXT, 0, eax
        stdcall StrDel
        jmp     .ondefault
endwp





proc CreateBitValue hwnd
local .lvi:LVITEM
        push    esi edi ebx
        xor     edi, edi
        xor     ebx, ebx

        invoke  SendDlgItemMessage, [hwnd], 102, CB_GETCURSEL, ebx, ebx
        cmp     eax, CB_ERR
        je      .getchecked

        invoke  SendDlgItemMessage, [hwnd], 102, CB_GETITEMDATA, eax, ebx
        or      edi, eax

.getchecked:
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_GETITEMCOUNT, ebx, ebx
        mov     esi, eax

.itemloop:
        dec     esi
        js      .endloop

        mov     [.lvi.iItem], esi
        mov     [.lvi.iSubItem], ebx
        mov     [.lvi.mask], LVIF_PARAM or LVIF_STATE
        mov     [.lvi.stateMask], LVIS_STATEIMAGEMASK
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], 101, LVM_GETITEM, ebx, eax

        cmp     [.lvi.state], $1000
        je      .itemloop

        or      edi, [.lvi.lParam]
        jmp     .itemloop

.endloop:
        invoke  GetWindowLong, [hwnd], 4
        mov     eax, [eax+TWinTemplateDT.DesignInfo]

        and     edi, [eax+TDesignTimeInfo.StyleMaskAnd]
        or      edi, [eax+TDesignTimeInfo.StyleMaskOr]

        mov     eax, edi
        pop     ebx edi esi
        ret
endp




iglobal
  cDefaultSubtype db 'Default',0

  CommonStyles:
    WinStyles                                                                               \
      WS_ICONICPOPUP, '..',                                               \
      WS_POPUP,       'Creates a pop-up window. This style cannot be used with the WS_CHILD style.',                                               \
      WS_CHILD,       'Creates a child window. This style cannot be used with the WS_POPUP style.',                                               \
      WS_MINIMIZE,    'Create window that is initially minimized.',       \
      WS_VISIBLE,     'The window is visible.',                           \
      WS_DISABLED,    'The window is disabled.',                          \
      WS_CLIPSIBLINGS,'Clip siblings.', \
      WS_CLIPCHILDREN,'Excludes the area occupied by child windows when drawing occurs within the parent window. This style is used when creating the parent window.',                                    \
      WS_MAXIMIZE,    'Creates a window that is initially maximized.',    \
      WS_CAPTION,     'Creates a window that has a title bar (includes the WS_BORDER style).', \
      WS_BORDER,      'Creates a window that has a thin-line border.',     \
      WS_DLGFRAME,    'Creates a window that has a border of a style typically used with dialog boxes. A window with this style cannot have a title bar.',    \
      WS_VSCROLL,     'Creates a window that has a vertical scroll bar.',  \
      WS_HSCROLL,     'Creates a window that has a horizontal scroll bar.',   \
      WS_SYSMENU,     'Creates a window that has a window-menu on its title bar. The WS_CAPTION style must also be specified.',       \
      WS_SIZEBOX,     'Creates a window that has a sizing border. Same as the WS_THICKFRAME style.',       \
      WS_TABSTOP,     'Specifies a control that can receive the keyboard focus when the user presses the TAB key.',   \
      WS_GROUP,       'Specifies the first control of a group of controls.', \
      WS_MAXIMIZEBOX, 'Creates a window that has a Maximize button. Cannot be combined with the WS_EX_CONTEXTHELP style. The WS_SYSMENU style must also be specified. ',\
      WS_MINIMIZEBOX, 'Creates a window that has a Minimize button. Cannot be combined with the WS_EX_CONTEXTHELP style. The WS_SYSMENU style must also be specified. '
endg






;----------------