;<ff
Window frmNewFromTemplate, 3, 0, 'TForm', 'New from template...', $160C0000, $10001, 0, 222, 195, 434, 325, frmTemplatesWinProc;
Window NONE, 0, 0, 'LISTBOX', 'Listbox', $50010103, $200, 200, 0, 32, 210, 192, 0;
Window NONE, 0, 0, 'STATIC', ' Description:', $50000200, $0, 0, 216, 8, 64, 24, 0;
Window NONE, 0, 0, 'EDIT', '', $50200844, $200, 201, 214, 32, 210, 192, 0;
Window NONE, 0, 0, 'STATIC', ' &Template:', $50000200, $0, 0, 0, 8, 56, 24, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010C00, $0, 2, 216, 264, 64, 24, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010C01, $0, 1, 144, 264, 64, 24, 0;
Window NONE, 0, 0, 'STATIC', 'Project location: ', $50000000, $0, 0, 8, 236, 80, 16, 0;
Window NONE, 2, 0, 'TButtonEdit', '', $50000080, $200, 101, 96, 232, 329, 21, 0;
;ff>
iglobal
  cProjectsPath        db '%fresh%\Projects\',0
  cSelectProjectFolder db 'Please select a folder for new project', 0
  cProjDirDoesntExist  db 'Project directory doesn''t exists. Would you like to create it?', 0
  cTemplateError       db 'Cannot create new project from template.', 0
endg

idPathEdit = 101

proc NewFromTemplate .wparam, .lparam
locals
.buffer rb 256
.finddata FINDDATA
.findhandle dd ?
.projectdir dd ?
.templatedir dd ?
.mainprjfile dd ?
endl
        mov     [.mainprjfile],0
        stdcall CreateForm, frmNewFromTemplate, [hMainWindow]
        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .endtemplate

        stdcall StrNew
        or      eax,eax
        jz      .endtemplate
        mov     [.projectdir],eax
        stdcall StrSetLength, eax,MAX_PATH
        or      eax,eax
        jz      .endtemplate
        stdcall StrPtr, [.projectdir]
        invoke  SendDlgItemMessage, ebx, idPathEdit, WM_GETTEXT, MAX_PATH, eax
        stdcall StrCharCat, [.projectdir],'\'


        stdcall DirExists, [.projectdir]
        or      eax,eax
        jnz     .project_dir_exists
        invoke  MessageBox,[hMainWindow],cProjDirDoesntExist,cMainTitle,MB_YESNO
        cmp     eax,IDYES
        jne     .template_error
        stdcall CreateNestedDir, [.projectdir]
        or      eax,eax
        jz      .template_error
.project_dir_exists:

; Close all open in the moment files.
;        stdcall OnCloseAll, 0, 0

; Open files of the directory like unsaved files.

; Get template directory
        invoke  SendDlgItemMessage, ebx, 200, LB_GETCURSEL, 0, 0
        lea     edi, [.buffer]
        invoke  SendDlgItemMessage, ebx, 200, LB_GETTEXT, eax, edi

        ; we don't need dialog to be open any more
        invoke  DestroyWindow, ebx

        stdcall ConvertPath, cTemplatesDir
        mov     esi, eax

        stdcall StrCat, esi, edi
        stdcall StrCharCat, esi, '\'
        mov     [.templatedir],esi
        stdcall StrDup, esi
        push    eax

        stdcall StrCat, eax, cFilterAll
        stdcall StrPtr, eax
        lea     ebx, [.finddata]
        invoke  FindFirstFile, eax, ebx
        mov     edx,eax
        stdcall StrDel ; from the stack
        cmp     edx, INVALID_HANDLE_VALUE
        je      .endtemplate

        mov     [.findhandle], eax

.allloop:
        test    [ebx+FINDDATA.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jnz     .nextfile

        ; copy files to new folder
        stdcall StrDup, [.templatedir]
        mov     esi,eax
        lea     ecx,[ebx+FINDDATA.cFileName]
        stdcall StrCat, eax,ecx
        stdcall StrDup, [.projectdir]
        mov     edi,eax
        lea     ecx,[ebx+FINDDATA.cFileName]
        stdcall StrCat, eax,ecx

        push    0
        stdcall StrPtr, edi
        push    eax
        stdcall StrPtr, esi
        push    eax
        invoke  CopyFile        ; arguments from stack
        or      eax,eax
        jz      .template_error


        stdcall StrDel,esi

        stdcall ExtractExt, edi
        or      eax,eax
        jz      @f
        cmp     byte[eax],0
        je      @f
        cmp     dword[eax],'.fpr'
        jne     @f
        mov     [.mainprjfile],edi
        jmp     .nextfile
     @@:
        stdcall StrDel,edi

.nextfile:
        invoke  FindNextFile, [.findhandle], ebx
        test    eax, eax
        jnz     .allloop
.findclose:
        invoke  FindClose, [.findhandle]

        ; open .PRJ file
        cmp     [.mainprjfile],0
        je      .template_error
        stdcall OpenFileByName, [.mainprjfile],0,TRUE

.endtemplate:
        stdcall StrDel, [.projectdir]
        ret
.template_error:
        invoke  MessageBox,[hMainWindow],cTemplateError,0,MB_OK+MB_ICONERROR
        ret
endp




winproc frmTemplatesWinProc
local string[1024]:BYTE

ondefault
        stc
        ret

onmessage AM_ONIDLE
        invoke  SendDlgItemMessage, [hwnd], 200, LB_GETCURSEL, 0, 0

        inc     eax
        push    eax

        invoke  GetDlgItem, [hwnd], IDOK
        invoke  EnableWindow, eax ; flag from the stack.

        clc
        ret

onmessage FM_AFTERCREATE

iglobal
  cTemplatesDir db '%finc%\templates\',0
  cFilterAll    db '*.*', 0
endg

locals
  .finddata FINDDATA
endl

        stdcall ConvertPath, cTemplatesDir
        mov     ebx, eax

        stdcall StrCat, ebx, cFilterAll
        stdcall StrPtr, ebx

        lea     edi, [.finddata]
        invoke  FindFirstFile, eax, edi
        cmp     eax, INVALID_HANDLE_VALUE
        je      .endoffill
        mov     esi, eax

.loop:
        test    [edi+FINDDATA.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jz      .nextfile

        cmp     byte [edi+FINDDATA.cFileName], '.'
        je      .nextfile

        lea     eax, [edi+FINDDATA.cFileName]
        invoke  SendDlgItemMessage, [hwnd], 200, LB_ADDSTRING, 0, eax

.nextfile:
        invoke  FindNextFile, esi, edi
        test    eax, eax
        jnz     .loop

        invoke  FindClose, esi
.endoffill:
        stdcall StrDel, ebx
        stdcall ConvertPath, cProjectsPath
        push    eax
        stdcall StrPtr,eax
        invoke  SendDlgItemMessage, [hwnd], idPathEdit, WM_SETTEXT, 0,eax
        stdcall StrDel   ; arg. from stack
        clc
        ret


onmessage WM_COMMAND
locals
  .buffer rb 100
endl
        cmp     word [wparam+2], LBN_SELCHANGE
        jne     .ondefault

        invoke  SendMessage, [lparam], LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .endcommand

        lea     esi, [.buffer]
        invoke  SendMessage, [lparam], LB_GETTEXT, eax, esi

        stdcall ConvertPath, cTemplatesDir
        mov     ebx, eax

iglobal
  cReadmeFile db '\readme.txt', 0
endg
        stdcall StrCat, ebx, esi
        stdcall StrCat, ebx, cReadmeFile

        stdcall LoadBinaryFile, ebx
        test    eax, eax
        jz      .endcommand

        mov     edi, eax

        invoke  SendDlgItemMessage, [hwnd], 201, WM_SETTEXT, 0, edi

        invoke  HeapFree, [hHeap], 0, edi
        stdcall StrDel, ebx

.endcommand:
        clc
        ret

onmessage BEM_BUTTONCLICK
        lea     edi, [string]
        invoke  SendDlgItemMessage, [hwnd], idPathEdit, WM_GETTEXT, 1024, edi
        stdcall SelectPathDialog, [hwnd], cSelectProjectFolder, edi
        test    eax,eax
        jz      .finish

        push    eax
        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [hwnd], idPathEdit, WM_SETTEXT, 0, eax
        stdcall StrDel ; From stack
.finish:
        clc
        ret

endwp

