;
;  APITools.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;
; This file contains set of wrappers for Windows API
;


;-----------------------------------------------------------------------------
; wrappers for Tree View control
;-----------------------------------------------------------------------------

; Returns lParam of the TreeView item.
proc GetTVItemParam uses ecx edx, hWnd, idTree, hItem
local item:TVITEM
        mov     eax,[hItem]
        test    eax,eax
        jz      .error
        mov     [item.hItem],eax
        mov     [item.mask], TVIF_PARAM
        lea     eax, [item]
        invoke  SendDlgItemMessage, [hWnd], [idTree], TVM_GETITEM, 0, eax
        test    eax, eax
        jz      .error
        mov     eax, [item.lParam]
        clc
        ret
.error:
        stc
        ret
endp