;<ff
Window frmEditorOptions, 3, 0, 'TForm', 'Editor options', $6480000, $10001, 0, 212, 183, 460, 320, EditorOptionsProc;
Window NONE, 0, 1, 'SysListView32', 'ListView', $5001208C, $200, 1000, 0, 0, 128, 286, 0;
Window NONE, 1, 3, 'TForm', 'Form', $50010000, $10100, 1001, 128, 0, 324, 40, ThemesPanelWinProc;
Window NONE, 0, 0, 'STATIC', 'T&hemes:', $50000202, $0, 0, 4, 8, 40, 21, 0;
Window NONE, 0, 0, 'BUTTON', '&Save', $50010000, $0, 103, 238, 8, 40, 21, 0;
Window NONE, 0, 0, 'BUTTON', '&Load', $50010000, $0, 102, 282, 8, 40, 21, 0;
Window NONE, 2, 0, 'COMBOBOX', '', $50010002, $10000, 101, 48, 8, 184, 150, 0;
Window NONE, 3, 4, 'TForm', 'Form', $50010000, $10100, 0, 128, 246, 324, 40, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 184, 8, 64, 25, 0;
Window NONE, 2, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 256, 8, 64, 25, 0;
;ff>

message OM_UPDATEDIALOG
message OM_THEMECHANGED


struct TEditorSettings
  ptrFontName  dd  ?
  FontSize     dd  ?
  FontCharset  dd  ?
  AsmEditStyle dd  ?
  ptrTheme     dd  ?
  size         dd  ?
ends

virtual at 0
  aeTheme AETHEME 0,0,0,0,0,0,1,0,0,0
end virtual

iglobal
  property propTempSettings, 'TempSettings'
  cDefaultThemesDirectory db '%finc%/themes/',0
endg


proc OnEditorOptions wparam, lparam
        stdcall CreateForm, frmEditorOptions, [hMainWindow]
        test    ebx, ebx
        jz      .finish

        stdcall ShowModal, ebx, MSF_CENTER
        invoke  DestroyWindow, ebx

.finish:
        ret
endp



;---------------------------------------------------------

winproc EditorOptionsProc

local .lvi:LVITEM

ondefault
        stc
        ret

onmessage OM_THEMECHANGED
        invoke  GetDlgItem, [hwnd], 1000
        mov     ebx, eax
        lea     edi, [.lvi]

        invoke  SendMessage, ebx, LVM_GETITEMCOUNT, 0, 0
        dec     eax
        mov     [edi+LVITEM.iItem], eax

        mov     [edi+LVITEM.mask], LVIF_PARAM
        mov     [edi+LVITEM.iSubItem], 0

.itemsave:
        invoke  SendMessage, ebx, LVM_GETITEM, 0, edi
        invoke  SendMessage, [edi+LVITEM.lParam], OM_UPDATEDIALOG, 0, 0
        dec     [edi+LVITEM.iItem]
        jns     .itemsave
        clc
        ret


onmessage WM_NOTIFY
        cmp     [wparam], 1000
        jne     .ondefault

        mov     esi, [lparam]
        cmp     [esi+NMHDR.code], LVN_ITEMCHANGED
        jne     .ondefault

        test    [esi+NMLISTVIEW.uChanged], LVIF_STATE
        jz      .ondefault

        mov     eax, [esi+NMLISTVIEW.uNewState]
        xor     eax, [esi+NMLISTVIEW.uOldState]
        test    eax, LVIS_FOCUSED
        jz      .ondefault

        mov     ecx, SW_SHOWNORMAL
        test    [esi+NMLISTVIEW.uNewState], LVIS_FOCUSED
        jnz     @f
        mov     ecx, SW_HIDE
@@:

; show window
        invoke  ShowWindow, [esi+NMLISTVIEW.lParam], ecx
        stdcall AlignChildren, [hwnd]

        clc
        ret



onmessage WM_COMMAND

        cmp     word [wparam], MR_OK
        jne     .ondefault

        invoke  GetProp, [hwnd], [propTempSettings]
        stdcall ThemeDuplicate, eax

        xchg    [CurrentSettings], eax
        stdcall DestroySettings, eax

        stdcall EnumOpenFiles, ApplyCurrentTheme, NULL

        stc
        ret


onmessage WM_DESTROY
        invoke  GetProp, [hwnd], [propTempSettings]
        stdcall DestroySettings, eax
        invoke  RemoveProp, [hwnd], [propTempSettings]
        stc
        ret

onmessage FM_AFTERCREATE
        stdcall ThemeDuplicate, [CurrentSettings]
        invoke  SetProp, [hwnd], [propTempSettings], eax
        invoke  SendDlgItemMessage, [hwnd], 1001, FM_AFTERCREATE, 0, 0

locals
  .hlv dd ?
endl
        invoke  GetDlgItem, [hwnd], 1000
        mov     [.hlv], eax

        stdcall ImageList_LoadGif, [hInstance], 283, 32, FALSE
        invoke  SendMessage, [.hlv], LVM_SETIMAGELIST, LVSIL_NORMAL, eax

        xor     esi, esi
        lea     edi, [.lvi]

        mov     [edi+LVITEM.mask], LVIF_TEXT or LVIF_PARAM or LVIF_IMAGE
        mov     [edi+LVITEM.iSubItem], 0

iglobal
  cEditOptionsApplets dd frmEditorColors, frmEditorBehaviour, 0
endg

.addloop:
        mov     ecx, [4*esi+cEditOptionsApplets]
        jecxz   .endadd

        stdcall CreateForm, ecx, [hwnd]
        stdcall SetAlign, ebx, waClient

        mov     [edi+LVITEM.lParam], ebx
        stdcall GetControlText, ebx, 0
        push    eax

        stdcall StrPtr, eax
        mov     [edi+LVITEM.pszText], eax
        mov     [edi+LVITEM.iImage], esi

        invoke  SendMessage, [.hlv], LVM_INSERTITEM, 0, edi

        stdcall StrDel ; from the stack.
        inc     esi
        jmp     .addloop

.endadd:
        invoke  SendMessage, [.hlv], LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_BORDERSELECT

        stdcall ListViewCenterIcons, [.hlv], 64

        mov     [.lvi.stateMask], TVIS_FOCUSED or TVIS_SELECTED
        mov     [.lvi.state], TVIS_FOCUSED or TVIS_SELECTED
        lea     eax, [.lvi]
        invoke  SendMessage, [.hlv], LVM_SETITEMSTATE, 0, eax

        clc
        ret
endwp




winproc ThemesPanelWinProc

ondefault
        stc
        ret

onmessage WM_COMMAND
        movzx   eax, word [wparam]

        cmp     eax, 102                  ; Load profile button ID
        je      .loadprofile

        cmp     eax, 103                  ; save profile button ID
        je      .saveprofile

        jmp     .ondefault


.saveprofile:
        invoke  GetParent, [hwnd]
        invoke  GetProp, eax, [propTempSettings]
        mov     edi, eax

        invoke  GetDlgItem, [hwnd], 101  ; profiles combo box
        stdcall GetControlText, eax, NULL
        push    eax
        stdcall StrPtr, eax

        stdcall SaveEditorSettings, eax, edi, FALSE
        stdcall StrDel ; from the stack
        test    eax, eax
        jnz     .errorload
        clc
        ret

.loadprofile:
        invoke  GetParent, [hwnd]
        mov     ebx, eax
        invoke  GetProp, ebx, [propTempSettings]
        mov     edi, eax

        invoke  GetDlgItem, [hwnd], 101  ; profiles combo box
        stdcall GetControlText, eax, NULL
        push    eax
        stdcall StrPtr, eax
        stdcall LoadEditorSettings, eax
        test    eax, eax
        jz      .errorload

        invoke  SetProp, ebx, [propTempSettings], eax
        stdcall DestroySettings, edi

        stdcall StrDel ; from the stack

        invoke  SendMessage, ebx, OM_THEMECHANGED, 0, 0
        clc
        ret

.errorload:
        invoke  GetLastError
        stdcall ErrorMessage, eax
        clc
        ret


onmessage FM_AFTERCREATE

locals
  .fd FINDDATA
endl

iglobal
  cThemesFilter db '%Finc%\themes\*.theme', 0
endg

; Fill combobox with saved themes
        invoke  GetDlgItem, [hwnd], 101
        mov     ebx, eax

        stdcall ConvertPath, cThemesFilter
        push    eax

        stdcall StrPtr, eax
        lea     ecx, [.fd]

        invoke  FindFirstFile, eax, ecx
        cmp     eax, INVALID_HANDLE_VALUE
        je      .endofsearch

        mov     esi, eax
        stdcall StrDel ; from the stack

.themeloop:
        test    [.fd.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jnz     .nextfile

        lea     eax, [.fd.cFileName]
        invoke  SendMessage, ebx, CB_ADDSTRING, 0, eax

.nextfile:
        lea     eax, [.fd]
        invoke  FindNextFile, esi, eax
        test    eax, eax
        jnz     .themeloop

        invoke  FindClose, esi

.endofsearch:
; select current theme if there is one
        invoke  SendMessage, ebx, CB_SELECTSTRING, -1, cCurrentEditorSettings

        clc
        ret

endwp



;---------------------------------------------------------


; EnumOpenFiles callback...
proc ApplyCurrentTheme .ptrFile, .dummy
        mov     esi, [.ptrFile]
        cmp     [esi+TOpenFile.hEditor], 0
        je      .exit

        stdcall GetAsmEdit, [esi+TOpenFile.hEditor]
        test    eax, eax
        jz      .exit

        mov     edi, eax
        mov     eax, [esi+TOpenFile.ptrType]

        stdcall ApplySettingsToAsmEdit, edi, [CurrentSettings], [eax+TFileType.lParam]

.exit:
        clc
        ret
endp



;------------------------------------------------------------------
; THIS PROCEDURE CAN AND MUST BE USED FOR SETTING PROPERTIES FOR
; ALL ASMEDIT WINDOWS
;------------------------------------------------------------------
proc ApplySettingsToAsmEdit .hAsmEdit, .ptrSettings, .ptrSyntaxProc
        push    esi ebx

        mov     esi, [.ptrSettings]

; Apply style
        invoke  GetWindowLong, [.hAsmEdit], GWL_STYLE
        and     eax, $ffffff00
        or      eax, [esi+TEditorSettings.AsmEditStyle]
        invoke  SetWindowLong, [.hAsmEdit], GWL_STYLE, eax

; Apply font
        invoke  SendMessage, [.hAsmEdit], WM_GETFONT, 0, 0
        mov     ebx, eax

        invoke  CreateFont, [esi+TEditorSettings.FontSize], 0, 0, 0, FW_NORMAL,                 \
                            0, 0, 0, [esi+TEditorSettings.FontCharset],                         \
                            OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,           \
                            FIXED_PITCH or FF_DONTCARE, [esi+TEditorSettings.ptrFontName]
        invoke  SendMessage, [.hAsmEdit], WM_SETFONT, eax, 0
        invoke  DeleteObject, ebx

; Apply colors and syntax highlighter
        invoke  SendMessage, [.hAsmEdit], AEM_SETTHEME, 0, [esi+TEditorSettings.ptrTheme]
;        invoke  SendMessage, [.hAsmEdit], AEM_SETSYNTAXHIGHLIGHT, 0, [.ptrSyntaxProc]

        pop     ebx esi
        ret
endp




;------------------------------------------
; Loads the file with editor settings and
; Returns pointer to its header.
;------------------------------------------
proc LoadEditorSettings .hThemeName
        stdcall StrDup, cDefaultThemesDirectory
        push    eax ; save for strdel
        stdcall StrCat, eax, [.hThemeName]
        stdcall ConvertPath, eax
        push    eax ; save for strdel

        stdcall LoadBinaryFile, eax
        test    eax, eax
        jz      .finish

; relocate pointers
        add     [eax+TEditorSettings.ptrFontName], eax
        mov     ecx, [eax+TEditorSettings.ptrTheme]
        add     ecx, eax
        mov     [eax+TEditorSettings.ptrTheme], ecx
        mov     [ecx+aeTheme.syntax_proc], fasm_syntax

.finish:
        stdcall StrDel    ; from stack
        stdcall StrDel    ; from stack
        ret
endp


proc SaveEditorSettings .hThemeName, .ptrTheme, .fOverWrite
        push    ebx esi

        mov     esi, [.ptrTheme]

        stdcall StrDup, cDefaultThemesDirectory
        push    eax ; save for strdel

        stdcall StrCat, eax, [.hThemeName]
        stdcall ConvertPath, eax
        mov     ebx, eax        ; filename

        stdcall FileExists, ebx
        test    eax, eax
        jz      .saveit

        cmp     [.fOverWrite], FALSE
        jne     .saveit

iglobal
  cThemeExists db 'The theme "',0
  cThemeExistsEnd db '" already exists. Do you want to overwrite it?',0
  cThemeExistsTitle db 'This theme already exist.',0
endg

        stdcall StrDup, cThemeExists
        push    eax
        stdcall StrCat, eax, [.hThemeName]
        stdcall StrCat, eax, cThemeExistsEnd
        stdcall StrPtr, eax
        invoke  MessageBox, [hApplication], eax, cThemeExistsTitle, MB_YESNO or MB_ICONQUESTION
        stdcall StrDel ; from stack
        cmp     eax, IDYES
        je      .saveit

        xor     eax, eax
        pop     esi ebx
        ret

.saveit:
        push    [esi+TEditorSettings.ptrFontName]
        push    [esi+TEditorSettings.ptrTheme]

        sub     [esi+TEditorSettings.ptrFontName], esi
        sub     [esi+TEditorSettings.ptrTheme], esi

        stdcall SaveBinaryFile, ebx, esi, [esi+TEditorSettings.size]

        pop     [esi+TEditorSettings.ptrTheme]
        pop     [esi+TEditorSettings.ptrFontName]

.finish:
        stdcall StrDel, ebx
        stdcall StrDel    ; from stack
        pop     esi ebx
        ret
endp


proc ThemeDuplicate .ptrTheme
        push    esi edi
        mov     esi, [.ptrTheme]

        push    [esi+TEditorSettings.ptrFontName]
        push    [esi+TEditorSettings.ptrTheme]

        sub     [esi+TEditorSettings.ptrFontName], esi
        sub     [esi+TEditorSettings.ptrTheme], esi

        invoke  HeapAlloc, [hHeap], HEAP_ZERO_MEMORY, [esi+TEditorSettings.size]
        mov     edi, eax
        push    eax
        push    esi

        mov     ecx, [esi+TEditorSettings.size]
        shr     ecx, 2

        rep movsd

        pop     esi
        pop     eax

        pop     [esi+TEditorSettings.ptrTheme]
        pop     [esi+TEditorSettings.ptrFontName]

        add     [eax+TEditorSettings.ptrFontName], eax
        add     [eax+TEditorSettings.ptrTheme], eax

        pop     edi esi
        ret
endp



proc DestroySettings .ptrSettings
        invoke  HeapFree, [hHeap], 0, [.ptrSettings]
        ret
endp

