;
;  LabelsList.inc
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

lfDefined = 1
lfCanRedefine = 2
lfRedefined = 4
lfUsed	    = 8

ltAbsolute = 0
ltRelocSegment = 1
ltRelocAbsolute = 2
ltRelocRelative = 3

; This is internal 32 byte (for now) structure of the FASM labels during
; assembling stage.

struct TIntLabel
  Value       dq ?     ; Value of the label
  Flags       dw ?     ; lf**** flags.
  DataSize    db ?
  type	      db ?     ; lt**** values.
  SIBEx       dd ?     ; ???
  PassDefined dw ?
  PassUsed    dw ?
  RelAddress  dd ?     ; Address of object section or external symbol to which this label is relative.
  Name	      dd ?     ; pointer to symbol name, with symbol length at offset -1
  LineAddress dd ?     ; pointer to preprocessed line
ends

struct TLabel
  Children    dd ?    ; Pointer to TArray of TLabel structures.
  iName       dd ?
  hashName    dd ?
  flags       dw ?
  DataSize    db ?
  type	      db ?
  ValueLo     dd ?
  ValueHi     dd ?
;              rb 32
ends

struct THashListItem
  hashname dd ?
  ptrName  dd ?
ends


struct TFileInfo
  hFileName    dd ?
  hashFileName dd ?
  ptrLineArray dd ?
ends

struct TLineInfo
  LineNum  dd ?
  Address  dd ?
ends