format PE GUI 4.0
entry start

include "%finc%/win32/win32a.inc"

include '%finc%/libs/strlib.inc'
include '%finc%/libs/gui.inc'
include '%finc%/libs/parents.inc'
include '%finc%/libs/msgutils.inc'
include '%finc%/libs/templates.inc'
include '%finc%/libs/tform.inc'
include '%finc%/libs/giflib.inc'
include '%finc%/libs/application.inc'


section '.code' code readable executable

include '%finc%/libs/strlib.asm'
include '%finc%/libs/gui.asm'
include '%finc%/libs/parents.asm'
include '%finc%/libs/msgutils.asm'
include '%finc%/libs/templates.asm'
include '%finc%/libs/tform.asm'
include '%finc%/libs/giflib.asm'
include '%finc%/libs/application.asm'

include 'actions.asm'

include 'Form1.frm'

uglobal
  hInstance       dd 0  ; Instance handle for common use.
  hHeap           dd 0

  hIml            dd 0
  hImlGray        dd 0
endg

iglobal
  cMainTitle db 'Visual test',0
endg

resAppIcon = 1
resMainToolbar = 2

start:
        invoke  GetModuleHandle,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

; Init common controls
        invoke  InitCommonControls      ;Ex,ComCtrlsFlags

        InitializeAll
        stdcall InitApplication, resAppIcon, cMainTitle

        stdcall CreateForm, Form1, [hApplication]
        mov     [hMainForm], ebx

;----------------------------------------------
; Main message loop
;----------------------------------------------
Run:
        call    ProcessMessages
        jc      .terminate

        invoke  SendMessage, [hApplication], AM_ONIDLE, 0, 0
        invoke  WaitMessage
        jmp     Run

.terminate:
        push    eax
        FinalizeAll
        invoke  ExitProcess


section '.data' data readable writeable
  data resource from 'resources/resources.res'
  end data

  IncludeAllGlobals


section '.idata' import data readable writeable
 library kernel32,'KERNEL32.DLL',\
          user32,'USER32.DLL',    \
          gdi32,'gdi32.dll',      \
          comctl32,'comctl32.dll',\
          comdlg32,'comdlg32.dll',\
          shell32, 'shell32.dll', \
          ole32,   'ole32.dll'

  include '%finc%\win32\api\kernel32.inc'
  include '%finc%\win32\api\user32.inc'
  include '%finc%\win32\api\gdi32.inc'
  include '%finc%\win32\api\ComCtl32.inc'
  include '%finc%\win32\api\ComDlg32.inc'
  include '%finc%\win32\api\Shell32.inc'
  include '%finc%\win32\api\ole32.inc'
