STR_MINCOUNT = 10	; minimum 10 strings in the table
STR_MINSTRLEN = 16	; 16 bytes minimum string length

struct TStrTable
  .count    dd 0	   ; max count of the strings in table.
  .LastHandle dd 0	   ; last allocated handle.
  .ptr	    dd 0	   ; pointer to the table data
  .heap     dd 0	   ; handle of strings heap
ends


; NumToStr flags
ntsSigned = $00000
ntsUnsigned = $10000
ntsZeroTerminated = $20000
ntsFixedWidth	  = $40000

ntsBin	= $0200
ntsQuad = $0400
ntsOct	= $0800
ntsDec	= $0a00
ntsHex	= $1000


;-------------------------------------
; It is stand-alone macroses
;-------------------------------------
macro IndexedStrings [lparam, string] {
  forward
    local ..lbl
    dd	..lbl, lparam
  common
    dd	0
  forward
..lbl db string, 0
}

