;************************************************************************
; Design time template structure.
;************************************************************************
struct TWinTemplateDT
  . TWinTemplate
  .parent     dd   ?
  .children   TList

  .ptrFile    dd   ?   ; pointer to TOpenFile structure. Only top-level window
                       ; have this field set.

  .hName      dd   ?   ; Design name of the control - in CT this is the label name of the control.

  .DesignInfo dd   ?   ; pointer to designtime info of the class
  .hwnd       dd   ?   ; handle of the created instance of the window.

  .hSizer     dd   ?   ; handle of TSizer control that handles operations on selected controls.
  .DragRect   RECT
ends
