;<ff
Window frmEditorBehaviour, 3, 0, 'TForm', 'Editor behaviour', $46000000, $10200, 0, 201, 191, 324, 246, EditorBehaviourWinProc;
Window NONE, 0, 0, 'BUTTON', 'Auto &brackets', $50014003, $0, 216, 176, 8, 104, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Tab indents selection', $50014003, $0, 264, 176, 128, 120, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Console caret', $50014003, $0, 232, 176, 108, 88, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Secure selection', $50014003, $0, 208, 176, 68, 104, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Optimal fill on saving', $50014003, $0, 204, 176, 88, 120, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Smart &tabulations', $50014003, $0, 202, 176, 48, 104, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Auto &Indents', $50014003, $0, 201, 176, 28, 104, 16, 0;
Window NONE, 2, 1, 'ASMEDIT', 'AsmEdit', $50800127, $200, 400, 0, 0, 168, 208, 0;
;ff>

winproc EditorBehaviourWinProc

ondefault
	stc
	ret

onmessage FM_AFTERCREATE

	invoke	SendDlgItemMessage, [hwnd], 400, WM_SETTEXT, 0, cPreviewSource


onmessage OM_UPDATEDIALOG
; Set properties for preview window.
	invoke	GetDlgItem, [hwnd], 400
	mov	esi, eax

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	ebx, eax

	stdcall ApplySettingsToAsmEdit, esi, ebx, fasm_syntax

	invoke	GetWindow, [hwnd], GW_CHILD
	mov	edi, [ebx+TEditorSettings.AsmEditStyle]

.stylesloop:
	mov	esi, eax
	invoke	GetWindowLong, esi, GWL_ID
	cmp	eax, 200
	jl	.nextcheckbox
	cmp	eax, 400
	jge	.nextcheckbox

	sub	eax, 200
	test	edi, eax
	setnz	al
	movzx	eax, al
	invoke	SendMessage, esi, BM_SETCHECK, eax, 0

.nextcheckbox:
	invoke	GetWindow, esi, GW_HWNDNEXT
	test	eax, eax
	jnz	.stylesloop

	clc
	ret


onmessage WM_COMMAND
; Recreate AsmEdit styles
	movsx	eax, word [wparam]
	cmp	eax, 200
	jl	.ondefault
	cmp	eax, 400
	jge	.ondefault

	xor	edi, edi
	invoke	GetWindow, [hwnd], GW_CHILD

.loop:
	mov	esi, eax

	invoke	GetWindowLong, esi, GWL_ID
	cmp	eax, 200
	jl	.next
	cmp	eax, 400
	jge	.next

	invoke	SendMessage, esi, BM_GETCHECK, 0, 0
	cmp	eax, BST_CHECKED
	jne	.next

	invoke	GetWindowLong, esi, GWL_ID
	sub	eax, 200
	or	edi, eax

.next:
	invoke	GetWindow, esi, GW_HWNDNEXT
	test	eax, eax
	jnz	.loop

	invoke	GetParent, [hwnd]
	invoke	GetProp, eax, [propTempSettings]
	mov	esi, eax

	mov	[esi+TEditorSettings.AsmEditStyle], edi

	invoke	GetDlgItem, [hwnd], 400
	stdcall ApplySettingsToAsmEdit, eax, esi, fasm_syntax

.exit:
	clc
	ret
endwp



;--------------------------------------------------------------

winproc FlagsGroupProc

ondefault
	stc
	ret

endwp