;<ff
Window frmHelpFiles, 3, 0, 'TForm', 'Helps and manuals', $46000000, $10200, 0, 307, 194, 320, 240, HelpFilesOptionsProc;
Window NONE, 0, 0, 'STATIC', '&Help file:', $50000000, $0, 0, 8, 8, 48, 13, 0;
Window NONE, 2, 0, 'TButtonEdit', '', $50010080, $200, 104, 8, 24, 296, 21, 0;
;ff>
idHelpEdit = 104


iglobal
  cHelpTitle  db 'Select help file:',0
  cHelpFilter db 'Help files (*.hlp)',0,'*.hlp',0
              db 0
endg


;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
winproc HelpFilesOptionsProc
local  .str[1024]:BYTE

ondefault
        stc
        ret

onmessage FM_AFTERCREATE
        invoke  SendDlgItemMessage, [hwnd], idHelpEdit, BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        clc
        ret

onmessage OM_LOADOPTIONS
        stdcall GetHelpFileName
        jc      @f
        push    eax
        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [hwnd], idHelpEdit, WM_SETTEXT, 0, eax
        stdcall StrDel ; from the stack
@@:
        clc
        ret


onmessage OM_SAVEOPTIONS

        lea     edi,[.str]
        invoke  SendDlgItemMessage, [hwnd], idHelpEdit, WM_GETTEXT, 1024, edi

        stdcall StrPtr, [hIniFileName]
        invoke  WritePrivateProfileString, cParamSection, cHelpKey, edi, eax

        clc
        ret


onmessage BEM_BUTTONCLICK

        lea     edi, [.str]

        cmp     [wparam], idHelpEdit
        je      .helpfile

        clc
        ret

.helpfile:
        invoke  SendMessage, [lparam], WM_GETTEXT, 1024, edi
        stdcall OpenFilesDialog, cHelpTitle, FALSE, cHelpFilter, _OnSetHelpCallback, edi, [hwnd]
        clc
        ret

endwp


proc _OnSetHelpCallback .hFileName, .hApplet
        stdcall StrPtr, [.hFileName]
        invoke  SendDlgItemMessage, [.hApplet], idHelpEdit, WM_SETTEXT, 0, eax
        ret
endp

