;<ff
Window	frmPropEditor, 3, 0, 'TForm', 'Properties', $12CC0000, $10080, 0, 0, 100, 158, 0, PropEditorProc;
Window	NONE,  2, 5, 'TPropertyGrid', '', $56200000, $10200, 101, 0, 0, 100, 100, 0;
;ff>

uglobal
  hPropEditor	  dd 0	  ; handle of property editor
endg


;----------------------------------------
; Creates property editor.
; Call this only once.
;----------------------------------------

proc InitPropEditor .owner
	stdcall  CreateForm, frmPropEditor, [hApplication]
	mov	 [hPropEditor], ebx
	ret
endp


proc PropEditorProc .hwnd, .wmsg, .wparam, .lparam

local .buff[256]:BYTE
	call	JumpTo
	MessageList			\
	  WM_COMMAND,	  .command,	\
	  PRM_UPDATEPROP, .updateprop,	\
	  WM_CLOSE,	  .close,	\
	  WM_ERASEBKGND,  .erasebkgnd,	\
	  WM_SETFOCUS,	  .wmsetfocus,	\
	  WM_NEXTDLGCTL,  .wmnext

.qtrue:
	stc
	jmp	.finish

.wmnext:
	invoke	SendDlgItemMessage, [.hwnd], 101, [.wmsg], [.wparam], [.lparam]
	clc
	ret

;-------- WM_SETFOCUS ---------------------------------------
.wmsetfocus:

	invoke	GetDlgItem, [.hwnd], 101
	mov	ebx, eax

	invoke	SendMessage, ebx, PEM_GETCONTROL, 0, 0
	test	eax, eax
	jz	.setfocus

	invoke	SetWindowPos, [eax+TWinTemplateDT.hwnd], HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_SHOWWINDOW

.setfocus:
	invoke	SetFocus, ebx
	jmp	.qfalse

;-------- WM_ERASEBKGND -------------------------------------
.erasebkgnd:
	invoke	GetDlgItem, [.hwnd], 101
	invoke	IsWindowVisible, eax
	test	eax, eax
	jz	.qtrue

	xor	eax, eax
	inc	eax
	clc
	ret

;-------- WM_CLOSE ------------------------------------------
.close:
	stdcall OnViewPropEditor, actViewPropEditor, 0
	jmp	.qfalse

;-------- PRM_UPDATEPROP ------------------------------------
.updateprop:
	invoke	GetDlgItem, [.hwnd], 101
	mov	ebx, eax
	invoke	InvalidateRect, ebx, NULL, FALSE
	jmp	.qfalse

;---------WM_COMMAND-----------------------------
.command:
	cmp	word [.wparam], MR_OK	; enter pressed.
	jne	.tomain

	invoke	SendDlgItemMessage, [.hwnd], 101, PEM_UPDATECONTROL, 0, 0
	jmp	.qfalse


.tomain:
	invoke	SendMessage, [hMainWindow], [.wmsg], [.wparam], [.lparam]
	jmp	.qtrue

.qfalse:
	xor	eax,eax
	clc
.finish:
	ret
endp


