; Import functions from sqlite.dll database engine.
; All functions have CCALL calling conventions...

import sqlite3,                                               \
  sqliteAggregateContext     , 'sqlite3_aggregate_context'   ,\
  sqliteAggregateCount       , 'sqlite3_aggregate_count'     ,\
  sqliteBindBlob             , 'sqlite3_bind_blob'           ,\
  sqliteBindDouble           , 'sqlite3_bind_double'         ,\
  sqliteBindInt              , 'sqlite3_bind_int'            ,\
  sqliteBindInt64            , 'sqlite3_bind_int64'          ,\
  sqliteBindNull             , 'sqlite3_bind_null'           ,\
  sqliteBindParameterCount   , 'sqlite3_bind_parameter_count',\
  sqliteBindParameterIndex   , 'sqlite3_bind_parameter_index',\
  sqliteBindParameterName    , 'sqlite3_bind_parameter_name' ,\
  sqliteBindText             , 'sqlite3_bind_text'           ,\
  sqliteBindText16           , 'sqlite3_bind_text16'         ,\
  sqliteBusyHandler          , 'sqlite3_busy_handler'        ,\
  sqliteBusyTimeout          , 'sqlite3_busy_timeout'        ,\
  sqliteChanges              , 'sqlite3_changes'             ,\
  sqliteClose                , 'sqlite3_close'               ,\
  sqliteCollationNeeded      , 'sqlite3_collation_needed'    ,\
  sqliteCollationNeeded16    , 'sqlite3_collation_needed16'  ,\
  sqliteColumnBlob           , 'sqlite3_column_blob'         ,\
  sqliteColumnBytes          , 'sqlite3_column_bytes'        ,\
  sqliteColumnBytes16        , 'sqlite3_column_bytes16'      ,\
  sqliteColumnCount          , 'sqlite3_column_count'        ,\
  sqliteColumnDecltype       , 'sqlite3_column_decltype'     ,\
  sqliteColumnDecltype16     , 'sqlite3_column_decltype16'   ,\
  sqliteColumnDouble         , 'sqlite3_column_double'       ,\
  sqliteColumnInt            , 'sqlite3_column_int'          ,\
  sqliteColumnInt64          , 'sqlite3_column_int64'        ,\
  sqliteColumnName           , 'sqlite3_column_name'         ,\
  sqliteColumnName16         , 'sqlite3_column_name16'       ,\
  sqliteColumnText           , 'sqlite3_column_text'         ,\
  sqliteColumnText16         , 'sqlite3_column_text16'       ,\
  sqliteColumnType           , 'sqlite3_column_type'         ,\
  sqliteCommitHook           , 'sqlite3_commit_hook'         ,\
  sqliteComplete             , 'sqlite3_complete'            ,\
  sqliteComplete16           , 'sqlite3_complete16'          ,\
  sqliteCreateCollation      , 'sqlite3_create_collation'    ,\
  sqliteCreateCollation16    , 'sqlite3_create_collation16'  ,\
  sqliteCreateFunction       , 'sqlite3_create_function'     ,\
  sqliteCreateFunction16     , 'sqlite3_create_function16'   ,\
  sqliteDataCount            , 'sqlite3_data_count'          ,\
  sqliteErrCode              , 'sqlite3_errcode'             ,\
  sqliteErrMsg               , 'sqlite3_errmsg'              ,\
  sqliteErrMsg16             , 'sqlite3_errmsg16'            ,\
  sqliteExec                 , 'sqlite3_exec'                ,\
  sqliteFinalize             , 'sqlite3_finalize'            ,\
  sqliteFree                 , 'sqlite3_free'                ,\
  sqliteFreeTable            , 'sqlite3_free_table'          ,\
  sqliteGetAuxData           , 'sqlite3_get_auxdata'         ,\
  sqliteGetTable             , 'sqlite3_get_table'           ,\
  sqliteInterrupt            , 'sqlite3_interrupt'           ,\
  sqliteLastInsertRowID      , 'sqlite3_last_insert_rowid'   ,\
  sqliteLibVersion           , 'sqlite3_libversion'          ,\
  sqliteMPrintF              , 'sqlite3_mprintf'             ,\
  sqliteOpen                 , 'sqlite3_open'                ,\
  sqliteOpen16               , 'sqlite3_open16'              ,\
  sqlitePrepare              , 'sqlite3_prepare'             ,\
  sqlitePrepare16            , 'sqlite3_prepare16'           ,\
  sqliteProgressHandler      , 'sqlite3_progress_handler'    ,\
  sqliteReset                , 'sqlite3_reset'               ,\
  sqliteResultBlob           , 'sqlite3_result_blob'         ,\
  sqliteResultDouble         , 'sqlite3_result_double'       ,\
  sqliteResultError          , 'sqlite3_result_error'        ,\
  sqliteResultError16        , 'sqlite3_result_error16'      ,\
  sqliteResultInt            , 'sqlite3_result_int'          ,\
  sqliteResultInt64          , 'sqlite3_result_int64'        ,\
  sqliteResultNull           , 'sqlite3_result_null'         ,\
  sqliteResultText           , 'sqlite3_result_text'         ,\
  sqliteResultText16         , 'sqlite3_result_text16'       ,\
  sqliteResultText16BE       , 'sqlite3_result_text16be'     ,\
  sqliteResultText16LE       , 'sqlite3_result_text16le'     ,\
  sqliteResultValue          , 'sqlite3_result_value'        ,\
  sqliteSetAuthorizer        , 'sqlite3_set_authorizer'      ,\
  sqliteSetAuxdata           , 'sqlite3_set_auxdata'         ,\
  sqliteSNPprintF            , 'sqlite3_snprintf'            ,\
  sqliteStep                 , 'sqlite3_step'                ,\
  sqliteTotalChanges         , 'sqlite3_total_changes'       ,\
  sqliteTrace                , 'sqlite3_trace'               ,\
  sqliteUserData             , 'sqlite3_user_data'           ,\
  sqliteValueBlob            , 'sqlite3_value_blob'          ,\
  sqliteValueBytes           , 'sqlite3_value_bytes'         ,\
  sqliteValueBytes16         , 'sqlite3_value_bytes16'       ,\
  sqliteValueDouble          , 'sqlite3_value_double'        ,\
  sqliteValueInt             , 'sqlite3_value_int'           ,\
  sqliteValueInt64           , 'sqlite3_value_int64'         ,\
  sqliteValueText            , 'sqlite3_value_text'          ,\
  sqliteValueText16          , 'sqlite3_value_text16'        ,\
  sqliteValueText16BE        , 'sqlite3_value_text16be'      ,\
  sqliteValueText16LE        , 'sqlite3_value_text16le'      ,\
  sqliteValueType            , 'sqlite3_value_type'          ,\
  sqliteVMprintF             , 'sqlite3_vmprintf'
