
; special header for code completion:
;  Win32 functions, structures and constants

include '%finc%/macro/struct.inc'
include '%finc%/macro/proc32.inc'
include '%finc%/macro/proc32ex.inc'
include '%finc%/macro/com32.inc'
include '%finc%/macro/import32.inc'
include '%finc%/macro/export.inc'
include '%finc%/macro/resource.inc'
include '%finc%/macro/globals.inc'
include '%finc%/macro/display.inc'
include '%finc%/macro/exceptions.inc'

struc CHAR val { match any, val \{ . db val \}
                 match , val \{ . db ? \} }

include '%finc%/equates/kernel32.inc'
include '%finc%/equates/user32.inc'
include '%finc%/equates/gdi32.inc'
include '%finc%/equates/comctl32.inc'
include '%finc%/equates/comdlg32.inc'
include '%finc%/equates/shell32.inc'
include '%finc%/equates/wsock32.inc'

include '%finc%/apia/kernel32.inc'
include '%finc%/apia/user32.inc'
include '%finc%/apia/gdi32.inc'
include '%finc%/apia/comctl32.inc'
include '%finc%/apia/comdlg32.inc'
include '%finc%/apia/shell32.inc'
include '%finc%/apia/wsock32.inc'