; Example of manually generated theme

; Assembly Editor styles
AES_AUTOINDENT	 = 0001h
AES_AUTOBRACKETS = 0002h
AES_SMARTTABS	 = 0004h
AES_SECURESEL	 = 0008h
AES_OPTIMALFILL  = 0010h
AES_CONSOLECARET = 0020h

macro .align value { rb (value-1)-($+value-1) mod value }

dd font_name		; pointer to font name, relative to beginning of a file
dd -12			; font size
dd 0			; charset
dd AES_SMARTTABS+\	; asm edit style
   AES_CONSOLECARET+\
   AES_OPTIMALFILL
dd theme		; theme colors
dd theme_size

font_name db 'Fixedsys', 0
.align 96

theme:
   dd 0xffffff	; standard text color
   dd 0x800000	; background color
   dd 0x000000	; selected text
   dd 0xc0c0c0	; selected background
   dd 0xc0c0c0	; margin color
   dd 0x000000	; margin border color
   dd 30	; margin width
   dd 0x000000	; active text
   dd 0xffff00	; active background
   dd 0 	; reserved for syntax procedure address
   dd 0xd0d0d0	;
   dd 0xffff00	;  syntax colors
   dd 0xffff00	;
   dd 0xa0a0a0	;
   dd 0x00ff00	;
   dd 0x00ffff	;

theme_size: