;
;  AboutBox.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;
; actAbout action handler
;
proc OnAbout .wparam, .lparam
	stdcall CreateForm, AboutForm, [hApplication]
	stdcall LoadGif, [hInstance], resBmpAbout
	push	eax
	invoke	SendDlgItemMessage, ebx, 101, STM_SETIMAGE, IMAGE_BITMAP, eax
	invoke	SendDlgItemMessage, ebx, 102, WM_SETTEXT, 0, cAboutText
	stdcall ShowModal, ebx, MSF_CENTER
	invoke	DestroyWindow, ebx
	invoke	DeleteObject
	ret
endp

iglobal
  ; About box form definition.
  Window AboutForm, wtParent or wtEnd, waNone, 'TForm', 'About "Fresh"...', WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_DLGFRAME, 0, NULL, 0, 0, 400, 300, NULL
  Window NONE, wtChild, waBottom, 'Button', 'Close', WS_VISIBLE or WS_CHILD or WS_BORDER, 0, MR_OK, 10, 50, 64, 25, NULL
  Window NONE, wtChild, waLeft, 'Static', '', WS_VISIBLE or WS_CHILD or SS_BITMAP or SS_CENTERIMAGE or WS_BORDER, 0, 101, 0, 10, 165, 19, NULL
  Window NONE, wtChild or wtEnd, waClient, 'Static', '', WS_VISIBLE or WS_CHILD or SS_LEFT or WS_BORDER, WS_EX_CLIENTEDGE, 102, 0, 10, 180, 19, NULL

  cAboutText db $0d, '  Fresh IDE', $0d, $0d
	     db '  version ', FRESH_VERSION, $0d
	     db '    build: '
	     create_build_time DAY, MONTH, YEAR, HOUR, MINUTES
	     db $0d, $0d
	     db '  Authors:', $0d
	     db '    John Found', $0d
	     db '    Fredrik Klasson (aka scientica)', $0d
	     db '    Tommy Lillehagen',$0d
	     db '    Mateusz Tymek', $0d
	     db '    Victor Loh (aka roticv)', $0d
	     db '    Yunus Sina Gulsen (aka VeSCeRa)', $0d, $0d
	     db '  Compiler: FASM ',VERSION_STRING, $0d
	     db '    Copyright (c) 1999-2006, Tomasz Grysztar', 0
endg