;<ff
Window frmEditPath, 3, 0, 'TForm', 'Input name and path', $6080000, $10001, 0, 271, 210, 320, 121, frmEditPathProc;
Window NONE, 0, 0, 'STATIC', '&Name:', $50000000, $0, 0, 8, 8, 32, 13, 0;
Window NONE, 0, 0, 'EDIT', '', $50010084, $200, 100, 8, 24, 72, 21, 0;
Window NONE, 0, 0, 'STATIC', '&Path:', $50000000, $0, 0, 88, 8, 32, 13, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $50010080, $200, 101, 88, 24, 216, 21, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 80, 56, 64, 25, 0;
Window NONE, 2, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 152, 56, 64, 25, 0;
;ff>
;
;  EditPath.frm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

iglobal
  cIncludeTitle db 'Select include directory:',0
endg

idAliasName = 100
idPathEdit  = 101

proc InputAliasName .hName, .hValue
        push    esi ebx
        stdcall CreateForm, frmEditPath, [hApplication]

        stdcall StrPtr, [.hName]
        invoke  SendDlgItemMessage, ebx, idAliasName, WM_SETTEXT, 0, eax
        stdcall StrPtr, [.hValue]
        invoke  SendDlgItemMessage, ebx, idPathEdit, WM_SETTEXT, 0, eax

        stdcall ShowModal, ebx, MSF_CENTER
        push    eax
        cmp     eax, MR_OK
        jne     .exit

        invoke  SendDlgItemMessage, ebx, idAliasName, WM_GETTEXTLENGTH, 0, 0
        lea     esi, [eax+1]
        stdcall StrSetLength, [.hName], esi
        invoke  SendDlgItemMessage, ebx, idAliasName, WM_GETTEXT, esi, eax

        invoke  SendDlgItemMessage, ebx, idPathEdit, WM_GETTEXTLENGTH, 0, 0
        lea     esi, [eax+1]
        stdcall StrSetLength, [.hValue], esi
        invoke  SendDlgItemMessage, ebx, idPathEdit, WM_GETTEXT, esi, eax

        stdcall RemoveEndSlash, [.hValue]

.exit:
        invoke  DestroyWindow, ebx
        pop     eax
        pop     ebx esi
        ret
endp



proc RemoveEndSlash .hPath
        push    edi ebx
        stdcall StrPtr, [.hPath]
        mov     edi, eax
        stdcall StrLen, [.hPath]
        mov     ebx, eax

        cmp     byte [edi+ebx-1], '\'
        je      .killslash
        cmp     byte [edi+eax-1], '/'
        jne     .pathok                 ; well more checks need, but later...

.killslash:
        mov     byte [edi+eax-1], 0

.pathok:
        pop     ebx edi
        ret
endp



proc frmEditPathProc .hwnd, .wmsg, .wparam, .lparam
local .str[1024]:BYTE

        cmp     ebx, BEM_BUTTONCLICK
        je      .selectfolder

        stc
        ret

.selectfolder:
        lea     edi, [.str]
        invoke  SendDlgItemMessage, [.hwnd], idPathEdit, WM_GETTEXT, 1024, edi
        stdcall SelectPathDialog, [hApplication], cIncludeTitle, edi
        test    eax,eax
        jz      .quit

        push    eax
        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [.hwnd], idPathEdit, WM_SETTEXT, 0, eax
        stdcall StrDel ; From stack

.quit:
        invoke  SetActiveWindow, [.hwnd]
        clc
        ret
endp
