;<ff
Window frmIDEOptions, 3, 0, 'TForm', 'Paths and Environment', $46000000, $10000, 0, 374, 251, 385, 338, IDEOptionsProc;
Window NONE, 0, 0, 'SysListView32', 'ListView', $5001800D, $200, 103, 8, 168, 368, 129, 0;
Window NONE, 1, 0, 'TForm', 'Form', $50000000, $10000, 0, 8, 135, 367, 32, 0;
Window NONE, 0, 0, 'STATIC', '&Environment Variables:', $50000200, $0, 0, 40, 4, 112, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Add', $50010000, $0, 100, 152, 4, 64, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Remove', $50010000, $0, 101, 224, 4, 64, 19, 0;
Window NONE, 2, 0, 'BUTTON', '&Edit', $50010000, $0, 102, 296, 4, 64, 19, 0;
Window NONE, 0, 0, 'STATIC', 'With Linux emulator like LINE you can run Linux applications under Windows.', $50000000, $0, 0, 8, 53, 368, 16, 0;
Window NONE, 0, 0, 'STATIC', 'Path to Linux emulator:', $50000000, $0, 0, 8, 8, 120, 16, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $50000080, $200, 105, 8, 24, 361, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Path to external debugger:', $50000000, $0, 0, 8, 80, 136, 16, 0;
Window NONE, 2, 0, 'TButtonEdit', '', $50000080, $200, 106, 8, 96, 361, 21, 0;
;ff>
;
;  EditPathOptions.frm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;


iglobal
  cLineTitle db 'Select Linux emulator:', 0
  cDbgTitle db 'Select external debuger:',0
  cExecutablesFilter db 'Executables (*.exe)',0,'*.exe',0
                     db 0
endg

winproc IDEOptionsProc
local .lvi:LVITEM
local .str[1024]:BYTE

.idButtonAdd  = 100
.idButtonDel  = 101
.idButtonEdit = 102
.idListView    = 103

idLinePathEdit = 105
idDebuggerEdit = 106


ondefault
        stc
        ret

;--------------------------------
; Init columns of the listview
;--------------------------------
onmessage FM_AFTERCREATE
locals
  .lvc LVCOLUMN
endl

iglobal
  cTitleKey db 'Name', 0
  cTitleVal db 'Path', 0
endg

        invoke  SendDlgItemMessage, [hwnd], idDebuggerEdit, BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        invoke  SendDlgItemMessage, [hwnd], idLinePathEdit, BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT
        lea     ebx, [.lvc]
        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_RIGHT
        mov     [.lvc.pszText], cTitleKey
        mov     [.lvc.iSubItem], 0
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_INSERTCOLUMN, 0, ebx
        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_LEFT
        mov     [.lvc.pszText], cTitleVal
        mov     [.lvc.iSubItem], 1
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_INSERTCOLUMN, 1, ebx
        clc
        ret


;----------------------------------------------------------
; Loads the path aliases ("environment variables") from
; the .ini file.
;-----------------------------------------------------------
onmessage OM_LOADOPTIONS
        stdcall PrefToDlgItem, prefDebugger,[hwnd],idDebuggerEdit
        stdcall PrefToDlgItem, prefLine,[hwnd],idLinePathEdit
        invoke  HeapAlloc, [hHeap], 0, 32768        ; get maximum buffer for INI section.
        mov     edi, eax
        stdcall StrPtr, [hIniFileName]
        invoke  GetPrivateProfileSection, _section_environment, edi, 32767, eax
; fill "evironment" variables to the listview.
        push    edi
.fillloop:
        mov     esi, edi
        cmp     byte [edi], 0
        je      .endoflist
.scaneq:
        cmp     byte [edi], 0
        je      .endofstring
        cmp     byte [edi], '='
        je      .eqfound
        inc     edi
        jmp     .scaneq
.endofstring:
        inc     edi
        jmp     .fillloop
.eqfound:
        mov     byte [edi],0
        inc     edi
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], esi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_INSERTITEM, 0, eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], eax
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], edi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETITEM, 0, eax
        xor     al,al
        mov     ecx, 32768
        repne   scasb
        jmp     .fillloop
.endoflist:
        pop     edi
        invoke  HeapFree, [hHeap], 0, edi
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE_USEHEADER
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETCOLUMNWIDTH, 1, LVSCW_AUTOSIZE_USEHEADER
        clc
        ret

;--------------------------------------------------------------------
; Saves the paths to the .ini file on exit of the dialog with MR_OK
;--------------------------------------------------------------------
onmessage OM_SAVEOPTIONS
        stdcall DlgItemToPref, prefDebugger,[hwnd],idDebuggerEdit
        stdcall DlgItemToPref, prefLine,[hwnd],idLinePathEdit
        invoke  HeapAlloc, [hHeap], 0, 32768
        mov     edi, eax
        xor     esi, esi
        push    edi
.getloop:
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], edi
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETITEMTEXT, esi, eax
        test    eax,eax
        jz      .endofitems
        add     edi, eax
        mov     byte [edi], '='
        inc     edi
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], edi
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETITEMTEXT, esi, eax
        add     edi, eax
        inc     edi
        inc     esi
        jmp     .getloop
.endofitems:
        mov     byte [edi], 0
        pop     edi
        stdcall StrPtr, [hIniFileName]
        invoke  WritePrivateProfileSection, _section_environment, edi, eax
        invoke  HeapFree, [hHeap], 0, edi
        clc
        ret

;-------------------------------------------------------------
; Well, executes the functions when
; one clicks on buttons "Add", "Edit", etc.
; Uses dialog box from the file "EditPath.frm"
;-------------------------------------------------------------
onmessage WM_COMMAND
        movzx   esi, word [wparam]
        cmp     esi, .idButtonAdd ; button near include path edit
        je      .addpath
        cmp     esi, .idButtonDel
        je      .delpath
        cmp     esi, .idButtonEdit
        jne     .ondefault
.editpath:
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .getselected
        clc
        ret
.getselected:
        mov     ebx, eax
        stdcall StrNew
        mov     esi, eax
        stdcall StrSetLength, esi, 1024
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax
        stdcall StrNew
        mov     edi, eax
        stdcall StrSetLength, edi, 1024
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax
        stdcall InputAliasName, esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings
        stdcall StrPtr, esi
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETITEMTEXT, ebx, eax
        stdcall StrPtr, edi
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETITEMTEXT, ebx, eax
.exitdelstrings:
        stdcall StrDel, esi
        stdcall StrDel, edi
        clc
        ret

.addpath:
        stdcall StrNew
        mov     esi, eax
        stdcall StrNew
        mov     edi, eax
        stdcall InputAliasName, esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings
        stdcall StrPtr, esi
        mov     [.lvi.pszText], eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_INSERTITEM, 0, eax
        lea     ecx, [.lvi]
        push    ecx
        push    eax
        stdcall StrPtr, edi
        mov     [.lvi.pszText], eax
        mov     [.lvi.iSubItem], 1
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_SETITEMTEXT
        jmp     .exitdelstrings
.delpath:
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .delselected
        clc
        ret
.delselected:
        invoke  SendDlgItemMessage, [hwnd], .idListView, LVM_DELETEITEM, eax, 0
        clc
        ret

onmessage BEM_BUTTONCLICK
        lea     edi, [.str]
        cmp     [wparam], idLinePathEdit
        je      .lineemul
        cmp     [wparam], idDebuggerEdit
        je      .debugfile
        clc
        ret
.lineemul:
        invoke  GetDlgItem, [hwnd], idLinePathEdit
        mov     esi, cLineTitle
        jmp     .commonButtonEdit

.debugfile:
        invoke  GetDlgItem, [hwnd], idDebuggerEdit
        mov     esi, cDbgTitle

.commonButtonEdit:
        mov     ebx, eax
        invoke  SendMessage, ebx, WM_GETTEXT, 1024, edi
        stdcall OpenFilesDialog, esi, FALSE, cExecutablesFilter, ButtonEditFileSelect, edi, ebx
        clc
        ret
endwp