;<ff
Window frmProjectOptions, 3, 0, 'TForm', 'Project options', $6C80000, $10001, 0, 207, 266, 320, 197, winprocProjectOptions;
Window NONE, 0, 0, 'COMBOBOX', 'Combobox', $54010002, $0, 101, 8, 96, 128, 180, 0;
Window NONE, 0, 0, 'STATIC', '&Binary filename:', $50000000, $0, 0, 8, 32, 88, 13, 0;
Window NONE, 0, 0, 'EDIT', '', $50010180, $200, 103, 8, 48, 297, 21, 0;
Window NONE, 0, 0, 'BUTTON', '&Automatic name creation.', $50010003, $0, 102, 8, 8, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 88, 136, 64, 25, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 160, 136, 64, 25, 0;
Window NONE, 0, 0, 'STATIC', 'kbytes', $50000200, $0, 0, 140, 96, 40, 21, 0;
Window NONE, 2, 0, 'STATIC', 'Compiler &memory:', $50000200, $0, 0, 8, 80, 80, 16, 0;
;ff>
;
;  ProjectOptions.frm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

idComboMemory  = 101
idCheckboxAuto = 102
idEditFilename = 103

proc OnProjectOptions .wparam, .lparam
        stdcall CreateForm, frmProjectOptions, [hApplication]
        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .exit

; Get parameters back...

; Memory size
        invoke  GetDlgItem, ebx, idComboMemory
        stdcall GetControlText, eax, NULL
        push    eax

        stdcall StrToFasmNum, eax
        mov     [poMemory], eax
        stdcall StrDel ; from the stack.

; Binary name
        invoke  GetDlgItem, ebx, idEditFilename
        stdcall GetControlText, eax, NULL
        stdcall StrDel, [poBinName]
        mov     [poBinName], eax

; Binary name auto flag
        invoke  SendDlgItemMessage, ebx, idCheckboxAuto, BM_GETCHECK, 0, 0
        mov     [poBinNameAuto], eax

; mark the project as modified...
        invoke  SendMessage, [hProjManager], _CEM_SETMODIFIED, TRUE, 0

.exit:
        invoke  DestroyWindow, ebx
        ret
endp


;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
winproc winprocProjectOptions
ondefault
        stc
        ret


onmessage FM_AFTERCREATE

        invoke  GetDlgItem, [hwnd], idComboMemory
        mov     ebx, eax

        mov     esi, cMemorySizes

.sizesloop:
        cmp     byte [esi], 0
        je      .endoflist

        invoke  SendMessage, ebx, CB_ADDSTRING, 0, esi
        stdcall StrLen, esi
        stc
        adc     esi, eax
        jmp     .sizesloop

.endoflist:
        stdcall NumToStr, [poMemory], NULL, 0, ntsUnsigned or ntsDec
        push    eax
        stdcall SetControlText, ebx, eax
        stdcall StrDel ; from the stack

; Set the binary filename.
        invoke   GetDlgItem, [hwnd], idEditFilename
        stdcall  SetControlText, eax, [poBinName]

; Set the check in checkbox.
        mov     esi, [poBinNameAuto]

        invoke  SendDlgItemMessage, [hwnd], idCheckboxAuto, BM_SETCHECK, esi, 0

        test    esi, esi
        jz      .endcreate

        xor     esi, 1
        invoke  GetDlgItem, [hwnd], idEditFilename
        invoke  EnableWindow, eax, esi

.endcreate:
        clc
        ret


onmessage WM_COMMAND
        cmp     word [wparam], idCheckboxAuto
        je      .checkautoname

        stc
        ret

.checkautoname:
        invoke  SendMessage, [lparam], BM_GETCHECK, 0, 0
        mov     ebx, eax

        xor     eax, 1
        push    eax
        invoke  GetDlgItem, [hwnd], idEditFilename
        invoke  EnableWindow, eax

        clc
        ret

endwp


iglobal
  cMemorySizes  db      '16384', 0
                db      '32768', 0
                db      '65536', 0
                db      '131072', 0
                db      '262144', 0
                db      '524288', 0
                db      '1048576', 0
                db      0
endg
