;
;  Prefs.inc
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;


; single preference
struct TPref
  pPrefType dd ?    ; pointer to TPrefType structure
  value     dd ?    ; depending on pPrefType it can be string pointer, number.. etc
  pszName   dd ?    ; preference name, for storing
  pszGroup  dd ?    ; INI file group or registry key
ends

; defines type of preference: text, flag, rect..
struct TPrefType
  pfnLoad    dd ?   ; loads preference from file
  pfnSave    dd ?   ; saves preference back
  pfnGet     dd ?   ; returns current value of preference
  pfnSet     dd ?   ; sets preference to given value
  pfnFree    dd ?   ; frees data occuppied by preference
  pfnToWnd   dd ?   ; sets given window according to value
  pfnFromWnd dd ?   ; retrives value from given window
ends

macro pref_list pref_name, [lbl,type,value,name,group] {
common
  pref_name:
forward
  local _name,_group
  if ~lbl eq
    lbl:
  end if
    dd type
    dd value
    dd _name
    dd _group
common
    dd 0   ; terminator
forward
  constStr _name,name
  constStr _group,group
}