;<ff
Window frmBrowser, 3, 0, 'TForm', 'Labels explorer', $160D0000, $0, 0, 202, 195, 480, 290, frmBrowserWinProc;
Window NONE, 1, 2, 'TForm', 'Form', $50800000, $100200, 1, 272, 0, 200, 263, 0;
Window NONE, 1, 0, 'BUTTON', 'Symbol kind', $54002007, $10000, 3, 8, 104, 180, 106, GroupboxProc;
Window NONE, 0, 0, 'BUTTON', 'Structures', $50000009, $0, 101, 8, 33, 80, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Data', $50000009, $0, 102, 8, 50, 80, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Show all', $50000009, $0, 104, 8, 84, 80, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Labels', $50000009, $0, 100, 8, 16, 80, 17, 0;
Window NONE, 2, 0, 'BUTTON', 'Constants', $50000009, $0, 103, 8, 67, 80, 17, 0;
Window NONE, 0, 0, 'STATIC', 'Size | Flags | type', $5000000B, $0, 0, 8, 56, 88, 19, 0;
Window NONE, 0, 0, 'EDIT', '', $50800884, $0, 11, 8, 76, 180, 17, 0;
Window NONE, 0, 0, 'EDIT', '', $50800884, $0, 10, 8, 28, 180, 17, 0;
Window NONE, 2, 0, 'STATIC', 'Value:', $5000000B, $0, 0, 8, 8, 64, 19, 0;
Window NONE, 2, 5, 'SysTreeView32', 'TreeView', $50000037, $200, 2, 0, 0, 272, 263, 0;
;ff>
iglobal
  cExplorerRoot db 'Root', 0
endg

proc OnExplorer, .wparam, .lparam
begin
        cmp     [ptrLabels], 0
        je      .finish
        stdcall CreateForm, frmBrowser, [hApplication]
        invoke  ShowWindow, ebx, SW_SHOWNORMAL

;        stdcall ShowModal, ebx, MSF_CENTER
;        invoke  DestroyWindow, ebx
.finish:
        return
endp



proc AddLabelsToTree, .tree, .parent, .ptrVarArray, .filterProc
.tvi  TVINSERTSTRUCT
begin
        push    esi ebx

        mov     eax, [.ptrVarArray]
        mov     esi, [eax]              ; pointer to TArray
        test    esi, esi
        jz      .finish

        mov     ebx, [esi+TArray.Count]
        lea     esi, [esi+TArray.Items]

.iteratelist:
;        cmp     [esi+TLabel.Children], 0        ; because some of the childrens
;        jne     .addit

        cmp     [.filterProc], 0
        je      .addit

        call    [.filterProc]
        jnc     .next

.addit:
        mov     eax, [.parent]
        mov     [.tvi.hParent], eax
        mov     ecx, TVI_LAST
        cmp     eax, TVI_ROOT
        jne     @f
        mov     ecx, TVI_SORT
@@:
        mov     [.tvi.hInsertAfter], ecx
        mov     [.tvi.item.mask], TVIF_TEXT or TVIF_PARAM

        mov     eax, [esi+TLabel.iName]
        add     eax, [ptrNames]
        mov     [.tvi.item.pszText], eax
        mov     [.tvi.item.lParam], esi

        lea     eax, [.tvi]
        invoke  SendMessage, [.tree], TVM_INSERTITEM, 0, eax

        cmp     dword [esi], 0
        je      .next
        stdcall AddLabelsToTree, [.tree], eax, esi, 0

.next:
        add     esi, sizeof.TLabel
        dec     ebx
        jnz     .iteratelist

.finish:
        pop     ebx esi
        return
endp




;**************************************************************************
; frmBrowser message handling procedure.
;
;   hwnd - handle of the form window
;   wmsg     - message code
;   wparam, lparam - parameters of the message
;**************************************************************************
proc frmBrowserWinProc, .hwnd, .wmsg, .wparam, .lparam
begin
        mov     ebx, [.wmsg]
        call    JumpTo
        MessageList                                             \
        FM_AFTERCREATE, .fmaftercreate,                         \
        WM_NOTIFY,      .wmnotify,                              \
        WM_CLOSE,       .wmclose

.default:
        stc
        return

.wmclose:
        invoke  DestroyWindow, [.hwnd]
        clc
        return

.fmaftercreate:
        invoke  GetDlgItem, [.hwnd], 1   ; static panel
        invoke  GetDlgItem, eax, 3      ; group box
        mov     ebx, eax
        invoke  SendDlgItemMessage, ebx, 100, BM_SETCHECK, 1, 0
        invoke  SendMessage, ebx, WM_COMMAND, 100, 0

        invoke  SetFocus, ebx

        clc
        return

.wmnotify:
        mov     esi, [.lparam]
        cmp     [esi+NMHDR.code], TVN_SELCHANGED
        je      .selchanged

        jmp     .default

; selection of the treeview changed.
.selchanged:
; Pointer to TLabel structure of given label.
        invoke  GetDlgItem, [.hwnd], 1
        mov     ebx, eax

        mov     edi, [esi+NMTREEVIEW.itemNew.lParam]
        test    edi, edi
        jz      .finish


        stdcall NumToStr, [edi+TLabel.ValueLo], 0, 0, ntsUnsigned or ntsHex or ntsZeroTerminated
        push    eax
        push    eax

        stdcall NumToStr, [edi+TLabel.ValueHi], 0, 0, ntsUnsigned or ntsHex or ntsZeroTerminated
        stdcall StrInsertChar, eax, '$', 0
        stdcall StrCharCat, eax, ':'

        stdcall StrCat, eax     ; second from the stack
        stdcall StrDel
        push    eax

        stdcall StrPtr, eax

        invoke  SendDlgItemMessage, ebx, 10, WM_SETTEXT, 0, eax
        stdcall StrDel

        movzx   eax, [edi+TLabel.DataSize]
        stdcall NumToStr, eax, 0, 0, ntsHex or ntsZeroTerminated or ntsFixedWidth + 2
        mov     edx, eax
        stdcall StrCat, edx, cStrDelimiter
        movzx   eax, [edi+TLabel.flags]
        stdcall NumToStr, eax, 0, 0, ntsHex or ntsZeroTerminated or ntsFixedWidth + 4
        push    eax
        stdcall StrCat, edx, eax
        stdcall StrDel ; from the stack
        stdcall StrCat, edx, cStrDelimiter
        movzx   eax, [edi+TLabel.type]
        stdcall NumToStr, eax, 0, 0, ntsHex or ntsZeroTerminated or ntsFixedWidth + 2
        push    eax
        stdcall StrCat, edx, eax
        stdcall StrDel ; from the stack

        stdcall StrPtr, edx
        push    edx
        invoke  SetDlgItemText, ebx, 11, eax
        stdcall StrDel ; from the stack

.finish:
        clc
        return

iglobal
  cSizeConst db 'const',0
  cSizeByte db 'byte', 0
  cSizeWord db 'word', 0
  cSizeDword db 'dword', 0
  cSizeQword db 'qword', 0
  cStrDelimiter db ' | ', 0
endg

endp




proc GroupboxProc, .hwnd, .wmsg, .wparam, .lparam
begin
        cmp     [.wmsg], WM_COMMAND
        je      .wmcommand
.default:
        stc
        return

.wmcommand:
        movzx   eax, word [.wparam]
        cmp     eax, 100
        jl      .default
        cmp     eax, 104
        jg      .default

.update:
; Update tree-view control
        push    eax

        invoke  GetParent, [.hwnd]
        invoke  GetParent, eax
        invoke  GetDlgItem, eax, 2
        mov     edi, eax
        invoke  LockWindowUpdate, edi
        invoke  SendMessage, edi, TVM_DELETEITEM, 0, TVI_ROOT

        pop     eax

        mov     edx, procCheckForLabel
        cmp     eax, 100
        je      .filterok

        mov     edx, procCheckForStruct
        cmp     eax, 101
        je      .filterok

        mov     edx, procCheckForData
        cmp     eax, 102
        je      .filterok

        mov     edx, procCheckForConst
        cmp     eax, 103
        je      .filterok

        xor     edx, edx

.filterok:
        stdcall AddLabelsToTree, edi, TVI_ROOT, ptrLabels, edx
        invoke  LockWindowUpdate, NULL
        clc
        return
endp





;------------------------------------------------
; FILTER PROCEDURES
;------------------------------------------------

proc procCheckForLabel
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        test    [esi+TLabel.flags], lfOptimized
        jz      .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp


proc procCheckForStruct
begin
        cmp     [esi+TLabel.ValueLo], 0
        jne     .no
        cmp     [esi+TLabel.ValueHi], 0
        jne     .no

        test    [esi+TLabel.flags], lfOptimized
        jnz      .no

        test    [esi+TLabel.flags], lfDefined
        jz      .no

        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp



proc procCheckForData
begin
        cmp     [esi+TLabel.DataSize], 0
        je      .no
        stc
        return

.no:    clc
        return
endp



proc procCheckForConst
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jz      .no
        stc
        return
.no:    clc
        return
endp
