;<ff
Window frmProjectOptions, 3, 0, 'TForm', 'Project options', $4C80000, $110001, 0, 447, 88, 336, 357, winprocProjectOptions;
Window NONE, 0, 0, 'COMBOBOX', 'Combobox', $54010002, $0, 701, 8, 80, 144, 180, 0;
Window NONE, 0, 0, 'STATIC', '&Binary filename:', $50000000, $0, 0, 8, 24, 88, 13, 0;
Window NONE, 0, 0, 'EDIT', '', $50010180, $200, 703, 8, 40, 304, 21, 0;
Window NONE, 0, 0, 'BUTTON', '&Automatic name creation.', $50010003, $0, 702, 8, 8, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 96, 296, 64, 25, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 168, 296, 64, 25, 0;
Window NONE, 0, 0, 'STATIC', 'kbytes', $50000200, $0, 0, 156, 80, 40, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Compiler &memory:', $50000200, $0, 0, 8, 64, 80, 16, 0;
Window NONE, 2, 0, 'TForm', 'Form', $50800000, $10000, 704, 8, 112, 315, 176, 0;
;ff>
idComboMemory  = 701
idCheckboxAuto = 702
idEditFilename = 703
idAliasesPanel = 704

idAliasList = 1234


proc OnProjectOptions, .wparam, .lparam
begin
        push    ebx

        stdcall CreateForm, frmProjectOptions, [hApplication]
        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .exit

; Get parameters back...

; Aliases:
        invoke  GetDlgItem, ebx, idAliasesPanel
        invoke  GetWindow, eax, GW_CHILD
        invoke  SendMessage, eax, OM_SAVEOPTIONS, 0, poVarArray

        stdcall CreateParametersMenu

; Memory size
        invoke  GetDlgItem, ebx, idComboMemory
        stdcall GetControlText, eax, NULL
        push    eax

        stdcall StrToFasmNum, eax
        mov     [poMemory], eax
        stdcall StrDel ; from the stack.

; Binary name
        invoke  GetDlgItem, ebx, idEditFilename
        stdcall GetControlText, eax, NULL
        stdcall StrDel, [poBinName]
        mov     [poBinName], eax

; Binary name auto flag
        invoke  SendDlgItemMessage, ebx, idCheckboxAuto, BM_GETCHECK, 0, 0
        mov     [poBinNameAuto], eax

; mark the project as modified...
        invoke  SendMessage, [hProjManager], _CEM_SETMODIFIED, TRUE, 0

.exit:
        invoke  DestroyWindow, ebx

        pop     ebx
        return
endp


;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
winproc winprocProjectOptions
begin


ondefault
        stc
        return


onmessage FM_AFTERCREATE

        invoke  GetDlgItem, [.hwnd], idAliasesPanel

        stdcall CreateForm, frmIDEOptions, eax
        stdcall SetAlign, ebx, waClient
        invoke  SetWindowLong, ebx, GWL_ID, idAliasList


        invoke  SendMessage, ebx, OM_LOADOPTIONS, 0, poVarArray

        invoke  GetDlgItem, [.hwnd], idComboMemory
        mov     ebx, eax

        mov     esi, cMemorySizes

.sizesloop:
        cmp     byte [esi], 0
        je      .endoflist

        invoke  SendMessage, ebx, CB_ADDSTRING, 0, esi
        stdcall StrLen, esi
        stc
        adc     esi, eax
        jmp     .sizesloop

.endoflist:
        stdcall NumToStr, [poMemory], NULL, 0, ntsUnsigned or ntsDec
        push    eax
        stdcall SetControlText, ebx, eax
        stdcall StrDel ; from the stack

; Set the binary filename.
        invoke   GetDlgItem, [.hwnd], idEditFilename
        stdcall  SetControlText, eax, [poBinName]

; Set the check in checkbox.
        mov     esi, [poBinNameAuto]
        invoke  SendDlgItemMessage, [.hwnd], idCheckboxAuto, BM_SETCHECK, esi, 0

        test    esi, esi
        jz      .endcreate

        xor     esi, 1
        invoke  GetDlgItem, [.hwnd], idEditFilename
        invoke  EnableWindow, eax, esi

.endcreate:
        clc
        return


onmessage WM_COMMAND
        cmp     word [.wparam], idCheckboxAuto
        je      .checkautoname

        stc
        return

.checkautoname:
        invoke  SendMessage, [.lparam], BM_GETCHECK, 0, 0
        mov     ebx, eax

        xor     eax, 1
        push    eax
        invoke  GetDlgItem, [.hwnd], idEditFilename
        invoke  EnableWindow, eax

        clc
        return

endwp


iglobal
  cMemorySizes  db      '16384', 0
                db      '32768', 0
                db      '65536', 0
                db      '131072', 0
                db      '262144', 0
                db      '524288', 0
                db      '1048576', 0
                db      0
endg
