;<ff
Window frmNewFromTemplate, 3, 0, 'TForm', 'New from template...', $160C0000, $10001, 0, 222, 195, 434, 285, frmTemplatesWinProc;
Window NONE, 0, 0, 'LISTBOX', 'Listbox', $50010103, $200, 100, 0, 24, 210, 192, 0;
Window NONE, 0, 0, 'STATIC', ' Description:', $50000200, $0, 0, 216, 0, 64, 24, 0;
Window NONE, 0, 0, 'EDIT', '', $50200844, $200, 101, 214, 24, 210, 192, 0;
Window NONE, 0, 0, 'STATIC', ' &Template:', $50000200, $0, 0, 0, 0, 56, 24, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010C00, $0, 2, 216, 224, 64, 24, 0;
Window NONE, 2, 0, 'BUTTON', 'OK', $50010C01, $0, 1, 144, 224, 64, 24, 0;
;ff>
iglobal
  cProjectsPath db '%fresh%\',0
endg

proc NewFromTemplate, .wparam, .lparam
.buffer rb 256
.finddata FINDDATA
.findhandle dd ?
.projectdir dd ?
begin
        stdcall ConvertPath, cProjectsPath
        mov     [.projectdir], eax

        stdcall CreateForm, frmNewFromTemplate, [hApplication]
        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .endtemplate


; Close all open in the moment files.
;        stdcall OnCloseAll, 0, 0

; Open files of the directory like unsaved files.

; Get template directory
        invoke  SendDlgItemMessage, ebx, 100, LB_GETCURSEL, 0, 0
        lea     edi, [.buffer]
        invoke  SendDlgItemMessage, ebx, 100, LB_GETTEXT, eax, edi

        stdcall ConvertPath, cTemplatesDir
        mov     esi, eax

        stdcall StrCat, esi, edi
        stdcall StrCharCat, esi, '\'

        lea     edi, [.finddata]

        stdcall StrDup, esi
        push    eax
        stdcall StrCat, eax, cFilterAll
        stdcall StrPtr, eax
        invoke  FindFirstFile, eax, edi
        stdcall StrDel ; from the stack

        cmp     eax, INVALID_HANDLE_VALUE
        je      .endtemplate

        mov     [.findhandle], eax

.allloop:
        test    [edi+FINDDATA.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jnz     .nextfile

        stdcall StrDup, [.projectdir]
        lea     ecx, [edi+FINDDATA.cFileName]
        stdcall StrCat, eax, ecx
        push    eax
        mov     edx, eax       ; new name in edx

        stdcall StrDup, esi
        push    eax
        lea     ecx, [edi+FINDDATA.cFileName]
        stdcall StrCat, eax, ecx   ; template name in eax

        stdcall OpenFileByName, edx, eax, TRUE

        stdcall StrDel ; from the stack
        stdcall StrDel ; from the stack

        test    eax, eax
        jz      .nextfile

        mov     edx, eax
        mov     [edx+TOpenFile.fNeverSaved], TRUE

.nextfile:
        invoke  FindNextFile, [.findhandle], edi
        test    eax, eax
        jnz     .allloop

.endtemplate:
        invoke  DestroyWindow, ebx
        stdcall StrDel, [.projectdir]
        return
endp




winproc frmTemplatesWinProc
begin

ondefault
        stc
        return

onmessage AM_ONIDLE
        invoke  SendDlgItemMessage, [.hwnd], 100, LB_GETCURSEL, 0, 0

        inc     eax
        push    eax

        invoke  GetDlgItem, [.hwnd], IDOK
        invoke  EnableWindow, eax ; flag from the stack.

        clc
        return

onmessage FM_AFTERCREATE

iglobal
  cTemplatesDir db '%finc%\templates\',0
  cFilterAll    db '*.*', 0
endg

locals
  .finddata FINDDATA
endl

        stdcall ConvertPath, cTemplatesDir
        mov     ebx, eax

        stdcall StrCat, ebx, cFilterAll
        stdcall StrPtr, ebx

        lea     edi, [.finddata]
        invoke  FindFirstFile, eax, edi
        cmp     eax, INVALID_HANDLE_VALUE
        je      .endoffill
        mov     esi, eax

.loop:
        test    [edi+FINDDATA.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jz      .nextfile

        cmp     byte [edi+FINDDATA.cFileName], '.'
        je      .nextfile

        lea     eax, [edi+FINDDATA.cFileName]
        invoke  SendDlgItemMessage, [.hwnd], 100, LB_ADDSTRING, 0, eax

.nextfile:
        invoke  FindNextFile, esi, edi
        test    eax, eax
        jnz     .loop

        invoke  FindClose, esi
.endoffill:
        stdcall StrDel, ebx
        clc
        return


onmessage WM_COMMAND
locals
  .buffer rb 100
endl
        cmp     word [.wparam+2], LBN_SELCHANGE
        jne     .ondefault

        invoke  SendMessage, [.lparam], LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .endcommand

        lea     esi, [.buffer]
        invoke  SendMessage, [.lparam], LB_GETTEXT, eax, esi

        stdcall ConvertPath, cTemplatesDir
        mov     ebx, eax

iglobal
  cReadmeFile db '\readme.txt', 0
endg
        stdcall StrCat, ebx, esi
        stdcall StrCat, ebx, cReadmeFile

        stdcall LoadBinaryFile, ebx
        test    eax, eax
        jz      .endcommand

        mov     edi, eax

        invoke  SendDlgItemMessage, [.hwnd], 101, WM_SETTEXT, 0, edi

        invoke  HeapFree, [hHeap], 0, edi
        stdcall StrDel, ebx

.endcommand:
        clc
        return

endwp



